// ==============================================================
// RTL generated by Vivado(TM) HLS - High-Level Synthesis from C, C++ and SystemC
// Version: 2019.1
// Copyright (C) 1986-2019 Xilinx, Inc. All Rights Reserved.
// 
// ===========================================================

`timescale 1 ns / 1 ps 

module decode_message6 (
        ap_clk,
        ap_rst,
        ap_start,
        ap_done,
        ap_idle,
        ap_ready,
        dest_array_address0,
        dest_array_ce0,
        dest_array_q0,
        dest_array_address1,
        dest_array_ce1,
        dest_array_q1,
        m_axi_size_AWVALID,
        m_axi_size_AWREADY,
        m_axi_size_AWADDR,
        m_axi_size_AWID,
        m_axi_size_AWLEN,
        m_axi_size_AWSIZE,
        m_axi_size_AWBURST,
        m_axi_size_AWLOCK,
        m_axi_size_AWCACHE,
        m_axi_size_AWPROT,
        m_axi_size_AWQOS,
        m_axi_size_AWREGION,
        m_axi_size_AWUSER,
        m_axi_size_WVALID,
        m_axi_size_WREADY,
        m_axi_size_WDATA,
        m_axi_size_WSTRB,
        m_axi_size_WLAST,
        m_axi_size_WID,
        m_axi_size_WUSER,
        m_axi_size_ARVALID,
        m_axi_size_ARREADY,
        m_axi_size_ARADDR,
        m_axi_size_ARID,
        m_axi_size_ARLEN,
        m_axi_size_ARSIZE,
        m_axi_size_ARBURST,
        m_axi_size_ARLOCK,
        m_axi_size_ARCACHE,
        m_axi_size_ARPROT,
        m_axi_size_ARQOS,
        m_axi_size_ARREGION,
        m_axi_size_ARUSER,
        m_axi_size_RVALID,
        m_axi_size_RREADY,
        m_axi_size_RDATA,
        m_axi_size_RLAST,
        m_axi_size_RID,
        m_axi_size_RUSER,
        m_axi_size_RRESP,
        m_axi_size_BVALID,
        m_axi_size_BREADY,
        m_axi_size_BRESP,
        m_axi_size_BID,
        m_axi_size_BUSER,
        size_offset,
        symbol_offset,
        price_offset,
        sell_or_buy_offset,
        is_system_event_offset,
        system_event_message_offset
);

parameter    ap_ST_fsm_state1 = 115'd1;
parameter    ap_ST_fsm_state2 = 115'd2;
parameter    ap_ST_fsm_state3 = 115'd4;
parameter    ap_ST_fsm_state4 = 115'd8;
parameter    ap_ST_fsm_state5 = 115'd16;
parameter    ap_ST_fsm_state6 = 115'd32;
parameter    ap_ST_fsm_state7 = 115'd64;
parameter    ap_ST_fsm_state8 = 115'd128;
parameter    ap_ST_fsm_state9 = 115'd256;
parameter    ap_ST_fsm_state10 = 115'd512;
parameter    ap_ST_fsm_state11 = 115'd1024;
parameter    ap_ST_fsm_state12 = 115'd2048;
parameter    ap_ST_fsm_state13 = 115'd4096;
parameter    ap_ST_fsm_state14 = 115'd8192;
parameter    ap_ST_fsm_state15 = 115'd16384;
parameter    ap_ST_fsm_state16 = 115'd32768;
parameter    ap_ST_fsm_state17 = 115'd65536;
parameter    ap_ST_fsm_state18 = 115'd131072;
parameter    ap_ST_fsm_state19 = 115'd262144;
parameter    ap_ST_fsm_state20 = 115'd524288;
parameter    ap_ST_fsm_state21 = 115'd1048576;
parameter    ap_ST_fsm_state22 = 115'd2097152;
parameter    ap_ST_fsm_state23 = 115'd4194304;
parameter    ap_ST_fsm_state24 = 115'd8388608;
parameter    ap_ST_fsm_state25 = 115'd16777216;
parameter    ap_ST_fsm_state26 = 115'd33554432;
parameter    ap_ST_fsm_state27 = 115'd67108864;
parameter    ap_ST_fsm_state28 = 115'd134217728;
parameter    ap_ST_fsm_state29 = 115'd268435456;
parameter    ap_ST_fsm_state30 = 115'd536870912;
parameter    ap_ST_fsm_state31 = 115'd1073741824;
parameter    ap_ST_fsm_state32 = 115'd2147483648;
parameter    ap_ST_fsm_state33 = 115'd4294967296;
parameter    ap_ST_fsm_state34 = 115'd8589934592;
parameter    ap_ST_fsm_state35 = 115'd17179869184;
parameter    ap_ST_fsm_state36 = 115'd34359738368;
parameter    ap_ST_fsm_state37 = 115'd68719476736;
parameter    ap_ST_fsm_state38 = 115'd137438953472;
parameter    ap_ST_fsm_state39 = 115'd274877906944;
parameter    ap_ST_fsm_state40 = 115'd549755813888;
parameter    ap_ST_fsm_state41 = 115'd1099511627776;
parameter    ap_ST_fsm_state42 = 115'd2199023255552;
parameter    ap_ST_fsm_state43 = 115'd4398046511104;
parameter    ap_ST_fsm_state44 = 115'd8796093022208;
parameter    ap_ST_fsm_state45 = 115'd17592186044416;
parameter    ap_ST_fsm_state46 = 115'd35184372088832;
parameter    ap_ST_fsm_state47 = 115'd70368744177664;
parameter    ap_ST_fsm_state48 = 115'd140737488355328;
parameter    ap_ST_fsm_state49 = 115'd281474976710656;
parameter    ap_ST_fsm_state50 = 115'd562949953421312;
parameter    ap_ST_fsm_state51 = 115'd1125899906842624;
parameter    ap_ST_fsm_state52 = 115'd2251799813685248;
parameter    ap_ST_fsm_state53 = 115'd4503599627370496;
parameter    ap_ST_fsm_state54 = 115'd9007199254740992;
parameter    ap_ST_fsm_state55 = 115'd18014398509481984;
parameter    ap_ST_fsm_state56 = 115'd36028797018963968;
parameter    ap_ST_fsm_state57 = 115'd72057594037927936;
parameter    ap_ST_fsm_state58 = 115'd144115188075855872;
parameter    ap_ST_fsm_state59 = 115'd288230376151711744;
parameter    ap_ST_fsm_state60 = 115'd576460752303423488;
parameter    ap_ST_fsm_state61 = 115'd1152921504606846976;
parameter    ap_ST_fsm_state62 = 115'd2305843009213693952;
parameter    ap_ST_fsm_state63 = 115'd4611686018427387904;
parameter    ap_ST_fsm_state64 = 115'd9223372036854775808;
parameter    ap_ST_fsm_state65 = 115'd18446744073709551616;
parameter    ap_ST_fsm_state66 = 115'd36893488147419103232;
parameter    ap_ST_fsm_state67 = 115'd73786976294838206464;
parameter    ap_ST_fsm_state68 = 115'd147573952589676412928;
parameter    ap_ST_fsm_state69 = 115'd295147905179352825856;
parameter    ap_ST_fsm_state70 = 115'd590295810358705651712;
parameter    ap_ST_fsm_state71 = 115'd1180591620717411303424;
parameter    ap_ST_fsm_state72 = 115'd2361183241434822606848;
parameter    ap_ST_fsm_state73 = 115'd4722366482869645213696;
parameter    ap_ST_fsm_state74 = 115'd9444732965739290427392;
parameter    ap_ST_fsm_state75 = 115'd18889465931478580854784;
parameter    ap_ST_fsm_state76 = 115'd37778931862957161709568;
parameter    ap_ST_fsm_state77 = 115'd75557863725914323419136;
parameter    ap_ST_fsm_state78 = 115'd151115727451828646838272;
parameter    ap_ST_fsm_state79 = 115'd302231454903657293676544;
parameter    ap_ST_fsm_state80 = 115'd604462909807314587353088;
parameter    ap_ST_fsm_state81 = 115'd1208925819614629174706176;
parameter    ap_ST_fsm_state82 = 115'd2417851639229258349412352;
parameter    ap_ST_fsm_state83 = 115'd4835703278458516698824704;
parameter    ap_ST_fsm_state84 = 115'd9671406556917033397649408;
parameter    ap_ST_fsm_state85 = 115'd19342813113834066795298816;
parameter    ap_ST_fsm_state86 = 115'd38685626227668133590597632;
parameter    ap_ST_fsm_state87 = 115'd77371252455336267181195264;
parameter    ap_ST_fsm_state88 = 115'd154742504910672534362390528;
parameter    ap_ST_fsm_state89 = 115'd309485009821345068724781056;
parameter    ap_ST_fsm_state90 = 115'd618970019642690137449562112;
parameter    ap_ST_fsm_state91 = 115'd1237940039285380274899124224;
parameter    ap_ST_fsm_state92 = 115'd2475880078570760549798248448;
parameter    ap_ST_fsm_state93 = 115'd4951760157141521099596496896;
parameter    ap_ST_fsm_state94 = 115'd9903520314283042199192993792;
parameter    ap_ST_fsm_state95 = 115'd19807040628566084398385987584;
parameter    ap_ST_fsm_state96 = 115'd39614081257132168796771975168;
parameter    ap_ST_fsm_state97 = 115'd79228162514264337593543950336;
parameter    ap_ST_fsm_state98 = 115'd158456325028528675187087900672;
parameter    ap_ST_fsm_state99 = 115'd316912650057057350374175801344;
parameter    ap_ST_fsm_state100 = 115'd633825300114114700748351602688;
parameter    ap_ST_fsm_state101 = 115'd1267650600228229401496703205376;
parameter    ap_ST_fsm_state102 = 115'd2535301200456458802993406410752;
parameter    ap_ST_fsm_state103 = 115'd5070602400912917605986812821504;
parameter    ap_ST_fsm_state104 = 115'd10141204801825835211973625643008;
parameter    ap_ST_fsm_state105 = 115'd20282409603651670423947251286016;
parameter    ap_ST_fsm_state106 = 115'd40564819207303340847894502572032;
parameter    ap_ST_fsm_state107 = 115'd81129638414606681695789005144064;
parameter    ap_ST_fsm_state108 = 115'd162259276829213363391578010288128;
parameter    ap_ST_fsm_state109 = 115'd324518553658426726783156020576256;
parameter    ap_ST_fsm_state110 = 115'd649037107316853453566312041152512;
parameter    ap_ST_fsm_state111 = 115'd1298074214633706907132624082305024;
parameter    ap_ST_fsm_state112 = 115'd2596148429267413814265248164610048;
parameter    ap_ST_fsm_state113 = 115'd5192296858534827628530496329220096;
parameter    ap_ST_fsm_state114 = 115'd10384593717069655257060992658440192;
parameter    ap_ST_fsm_state115 = 115'd20769187434139310514121985316880384;

input   ap_clk;
input   ap_rst;
input   ap_start;
output   ap_done;
output   ap_idle;
output   ap_ready;
output  [7:0] dest_array_address0;
output   dest_array_ce0;
input  [7:0] dest_array_q0;
output  [7:0] dest_array_address1;
output   dest_array_ce1;
input  [7:0] dest_array_q1;
output   m_axi_size_AWVALID;
input   m_axi_size_AWREADY;
output  [31:0] m_axi_size_AWADDR;
output  [0:0] m_axi_size_AWID;
output  [31:0] m_axi_size_AWLEN;
output  [2:0] m_axi_size_AWSIZE;
output  [1:0] m_axi_size_AWBURST;
output  [1:0] m_axi_size_AWLOCK;
output  [3:0] m_axi_size_AWCACHE;
output  [2:0] m_axi_size_AWPROT;
output  [3:0] m_axi_size_AWQOS;
output  [3:0] m_axi_size_AWREGION;
output  [0:0] m_axi_size_AWUSER;
output   m_axi_size_WVALID;
input   m_axi_size_WREADY;
output  [31:0] m_axi_size_WDATA;
output  [3:0] m_axi_size_WSTRB;
output   m_axi_size_WLAST;
output  [0:0] m_axi_size_WID;
output  [0:0] m_axi_size_WUSER;
output   m_axi_size_ARVALID;
input   m_axi_size_ARREADY;
output  [31:0] m_axi_size_ARADDR;
output  [0:0] m_axi_size_ARID;
output  [31:0] m_axi_size_ARLEN;
output  [2:0] m_axi_size_ARSIZE;
output  [1:0] m_axi_size_ARBURST;
output  [1:0] m_axi_size_ARLOCK;
output  [3:0] m_axi_size_ARCACHE;
output  [2:0] m_axi_size_ARPROT;
output  [3:0] m_axi_size_ARQOS;
output  [3:0] m_axi_size_ARREGION;
output  [0:0] m_axi_size_ARUSER;
input   m_axi_size_RVALID;
output   m_axi_size_RREADY;
input  [31:0] m_axi_size_RDATA;
input   m_axi_size_RLAST;
input  [0:0] m_axi_size_RID;
input  [0:0] m_axi_size_RUSER;
input  [1:0] m_axi_size_RRESP;
input   m_axi_size_BVALID;
output   m_axi_size_BREADY;
input  [1:0] m_axi_size_BRESP;
input  [0:0] m_axi_size_BID;
input  [0:0] m_axi_size_BUSER;
input  [29:0] size_offset;
input  [29:0] symbol_offset;
input  [29:0] price_offset;
input  [29:0] sell_or_buy_offset;
input  [29:0] is_system_event_offset;
input  [29:0] system_event_message_offset;

reg ap_done;
reg ap_idle;
reg ap_ready;
reg[7:0] dest_array_address0;
reg dest_array_ce0;
reg[7:0] dest_array_address1;
reg dest_array_ce1;
reg m_axi_size_AWVALID;
reg[31:0] m_axi_size_AWADDR;
reg[31:0] m_axi_size_AWLEN;
reg m_axi_size_WVALID;
reg[31:0] m_axi_size_WDATA;
reg[3:0] m_axi_size_WSTRB;
reg m_axi_size_BREADY;

(* fsm_encoding = "none" *) reg   [114:0] ap_CS_fsm;
wire    ap_CS_fsm_state1;
reg    size_blk_n_AW;
wire    ap_CS_fsm_state4;
reg    size_blk_n_W;
wire    ap_CS_fsm_state5;
reg    size_blk_n_B;
wire    ap_CS_fsm_state10;
reg   [0:0] icmp_ln12_reg_1577;
wire    ap_CS_fsm_state11;
wire    ap_CS_fsm_state12;
wire    ap_CS_fsm_state17;
reg   [0:0] icmp_ln15_reg_1592;
wire    ap_CS_fsm_state18;
wire    ap_CS_fsm_state19;
wire    ap_CS_fsm_state24;
wire    ap_CS_fsm_state20;
wire    ap_CS_fsm_state25;
wire    ap_CS_fsm_state21;
wire    ap_CS_fsm_state26;
wire    ap_CS_fsm_state22;
wire    ap_CS_fsm_state27;
wire    ap_CS_fsm_state23;
wire    ap_CS_fsm_state28;
wire    ap_CS_fsm_state29;
wire    ap_CS_fsm_state30;
wire    ap_CS_fsm_state31;
wire    ap_CS_fsm_state32;
wire    ap_CS_fsm_state33;
reg   [0:0] icmp_ln11_reg_1568;
wire    ap_CS_fsm_state35;
wire    ap_CS_fsm_state36;
wire    ap_CS_fsm_state41;
wire    ap_CS_fsm_state42;
wire    ap_CS_fsm_state43;
wire    ap_CS_fsm_state44;
wire    ap_CS_fsm_state45;
wire    ap_CS_fsm_state46;
wire    ap_CS_fsm_state47;
wire    ap_CS_fsm_state52;
reg   [0:0] icmp_ln39_reg_1816;
wire    ap_CS_fsm_state53;
wire    ap_CS_fsm_state54;
wire    ap_CS_fsm_state55;
wire    ap_CS_fsm_state56;
wire    ap_CS_fsm_state57;
wire    ap_CS_fsm_state58;
wire    ap_CS_fsm_state59;
wire    ap_CS_fsm_state64;
reg   [0:0] icmp_ln59_reg_1835;
wire    ap_CS_fsm_state65;
wire    ap_CS_fsm_state66;
wire    ap_CS_fsm_state67;
wire    ap_CS_fsm_state68;
wire    ap_CS_fsm_state69;
wire    ap_CS_fsm_state70;
wire    ap_CS_fsm_state71;
wire    ap_CS_fsm_state72;
wire    ap_CS_fsm_state73;
wire    ap_CS_fsm_state78;
reg   [0:0] icmp_ln83_reg_1855;
wire    ap_CS_fsm_state79;
wire    ap_CS_fsm_state80;
wire    ap_CS_fsm_state81;
wire    ap_CS_fsm_state82;
wire    ap_CS_fsm_state83;
wire    ap_CS_fsm_state84;
wire    ap_CS_fsm_state85;
wire    ap_CS_fsm_state86;
wire    ap_CS_fsm_state87;
wire    ap_CS_fsm_state92;
reg   [0:0] icmp_ln115_reg_1877;
wire    ap_CS_fsm_state93;
wire    ap_CS_fsm_state94;
wire    ap_CS_fsm_state95;
wire    ap_CS_fsm_state96;
wire    ap_CS_fsm_state97;
wire    ap_CS_fsm_state98;
wire    ap_CS_fsm_state99;
wire    ap_CS_fsm_state104;
reg   [0:0] icmp_ln145_reg_1899;
wire    ap_CS_fsm_state105;
wire    ap_CS_fsm_state106;
wire    ap_CS_fsm_state107;
wire    ap_CS_fsm_state108;
wire    ap_CS_fsm_state109;
wire    ap_CS_fsm_state110;
wire    ap_CS_fsm_state115;
reg   [0:0] icmp_ln36_reg_1787;
reg   [0:0] icmp_ln37_reg_1796;
reg   [0:0] icmp_ln167_reg_1919;
reg   [7:0] reg_987;
wire    ap_CS_fsm_state3;
reg    ap_block_state22_io;
reg    ap_block_state26_io;
reg   [7:0] reg_992;
reg    ap_block_state19_io;
reg   [7:0] reg_996;
reg    ap_block_state20_io;
reg    ap_block_state23_io;
reg   [7:0] reg_1000;
wire    ap_CS_fsm_state2;
wire   [15:0] tmp_fu_1004_p3;
reg   [15:0] tmp_reg_1563;
wire   [0:0] icmp_ln11_fu_1012_p2;
wire   [0:0] icmp_ln12_fu_1018_p2;
wire   [30:0] add_ln13_fu_1027_p2;
reg   [30:0] add_ln13_reg_1581;
wire   [0:0] icmp_ln15_fu_1043_p2;
reg    ap_block_state10;
wire   [30:0] add_ln16_fu_1052_p2;
reg   [30:0] add_ln16_reg_1596;
reg    ap_block_state17;
wire   [30:0] zext_ln21_fu_1068_p1;
reg   [30:0] zext_ln21_reg_1612;
wire   [30:0] add_ln21_fu_1071_p2;
reg   [30:0] add_ln21_reg_1617;
reg   [31:0] size_addr_26_reg_1622;
reg   [7:0] dest_array_load_11_reg_1656;
reg    ap_block_state21_io;
wire   [30:0] add_ln21_3_fu_1120_p2;
reg   [30:0] add_ln21_3_reg_1664;
reg   [7:0] dest_array_load_16_reg_1669;
reg   [31:0] size_addr_27_reg_1686;
reg   [7:0] dest_array_load_6_reg_1715;
reg    ap_block_state24_io;
reg   [7:0] dest_array_load_7_reg_1720;
wire   [30:0] add_ln24_5_fu_1179_p2;
reg   [30:0] add_ln24_5_reg_1735;
reg    ap_block_state25_io;
reg   [7:0] dest_array_load_12_reg_1740;
reg   [7:0] dest_array_load_13_reg_1745;
wire   [31:0] add_ln24_2_fu_1246_p2;
reg   [31:0] add_ln24_2_reg_1760;
wire   [30:0] add_ln27_5_fu_1265_p2;
reg   [30:0] add_ln27_5_reg_1771;
wire   [31:0] add_ln27_2_fu_1321_p2;
reg   [31:0] add_ln27_2_reg_1776;
reg    ap_block_state27_io;
wire   [0:0] icmp_ln36_fu_1337_p2;
reg    ap_block_state33;
wire   [0:0] icmp_ln37_fu_1342_p2;
wire    ap_CS_fsm_state34;
wire   [30:0] add_ln38_fu_1351_p2;
reg   [30:0] add_ln38_reg_1800;
wire    ap_CS_fsm_state40;
wire   [0:0] icmp_ln39_fu_1367_p2;
wire   [30:0] add_ln40_fu_1376_p2;
reg   [30:0] add_ln40_reg_1820;
wire   [0:0] icmp_ln59_fu_1392_p2;
reg    ap_block_state52;
wire   [30:0] add_ln60_fu_1401_p2;
reg   [30:0] add_ln60_reg_1839;
wire   [0:0] icmp_ln83_fu_1417_p2;
reg    ap_block_state64;
wire   [30:0] add_ln84_fu_1426_p2;
reg   [30:0] add_ln84_reg_1859;
wire   [0:0] icmp_ln115_fu_1442_p2;
reg    ap_block_state78;
wire   [30:0] add_ln116_fu_1451_p2;
reg   [30:0] add_ln116_reg_1881;
wire   [0:0] icmp_ln145_fu_1467_p2;
reg    ap_block_state92;
wire   [30:0] add_ln146_fu_1476_p2;
reg   [30:0] add_ln146_reg_1903;
wire   [0:0] icmp_ln167_fu_1492_p2;
reg    ap_block_state104;
wire   [30:0] add_ln168_fu_1501_p2;
reg   [30:0] add_ln168_reg_1923;
wire   [63:0] zext_ln13_3_fu_1033_p1;
wire   [63:0] zext_ln16_3_fu_1058_p1;
wire   [63:0] zext_ln21_17_fu_1077_p1;
wire   [63:0] zext_ln21_21_fu_1138_p1;
wire   [63:0] zext_ln24_3_fu_1252_p1;
wire   [63:0] zext_ln27_3_fu_1327_p1;
wire   [63:0] zext_ln38_3_fu_1357_p1;
wire   [63:0] zext_ln40_3_fu_1382_p1;
wire   [63:0] zext_ln60_3_fu_1407_p1;
wire   [63:0] zext_ln84_3_fu_1432_p1;
wire   [63:0] zext_ln116_3_fu_1457_p1;
wire   [63:0] zext_ln146_3_fu_1482_p1;
wire   [63:0] zext_ln168_3_fu_1507_p1;
wire   [31:0] zext_ln21_18_fu_1087_p1;
wire   [31:0] zext_ln21_19_fu_1100_p1;
wire   [31:0] zext_ln21_20_fu_1115_p1;
wire   [31:0] tmp_s_fu_1125_p5;
wire   [31:0] zext_ln21_22_fu_1148_p1;
wire   [31:0] zext_ln21_23_fu_1158_p1;
wire   [31:0] zext_ln21_24_fu_1171_p1;
wire   [31:0] tmp_2_fu_1185_p5;
reg    ap_predicate_op469_writeresp_state115;
reg    ap_block_state115;
wire   [30:0] zext_ln13_fu_1024_p1;
wire   [30:0] zext_ln16_fu_1049_p1;
wire   [15:0] tmp_10_fu_1092_p3;
wire   [23:0] tmp_11_fu_1105_p4;
wire   [15:0] tmp_12_fu_1152_p3;
wire   [23:0] tmp_13_fu_1163_p4;
wire   [30:0] zext_ln24_fu_1176_p1;
wire   [23:0] shl_ln24_1_fu_1204_p3;
wire   [15:0] shl_ln24_2_fu_1216_p3;
wire   [31:0] shl_ln_fu_1196_p3;
wire  signed [31:0] sext_ln24_fu_1212_p1;
wire  signed [16:0] sext_ln24_1_fu_1223_p1;
wire  signed [16:0] sext_ln24_2_fu_1227_p1;
wire   [16:0] add_ln24_1_fu_1236_p2;
wire  signed [31:0] sext_ln24_4_fu_1242_p1;
wire   [31:0] add_ln24_fu_1230_p2;
wire   [30:0] zext_ln27_fu_1262_p1;
wire   [23:0] shl_ln27_1_fu_1278_p3;
wire   [15:0] shl_ln27_2_fu_1289_p3;
wire   [31:0] shl_ln3_fu_1271_p3;
wire  signed [31:0] sext_ln27_fu_1285_p1;
wire  signed [16:0] sext_ln27_1_fu_1297_p1;
wire  signed [16:0] sext_ln27_2_fu_1301_p1;
wire   [16:0] add_ln27_1_fu_1311_p2;
wire  signed [31:0] sext_ln27_3_fu_1317_p1;
wire   [31:0] add_ln27_fu_1305_p2;
wire   [30:0] zext_ln38_fu_1348_p1;
wire   [30:0] zext_ln40_fu_1373_p1;
wire   [30:0] zext_ln60_fu_1398_p1;
wire   [30:0] zext_ln84_fu_1423_p1;
wire   [30:0] zext_ln116_fu_1448_p1;
wire   [30:0] zext_ln146_fu_1473_p1;
wire   [30:0] zext_ln168_fu_1498_p1;
reg   [114:0] ap_NS_fsm;

// power-on initialization
initial begin
#0 ap_CS_fsm = 115'd1;
end

always @ (posedge ap_clk) begin
    if (ap_rst == 1'b1) begin
        ap_CS_fsm <= ap_ST_fsm_state1;
    end else begin
        ap_CS_fsm <= ap_NS_fsm;
    end
end

always @ (posedge ap_clk) begin
    if ((((1'b0 == ap_block_state22_io) & (1'b1 == ap_CS_fsm_state22)) | (~((m_axi_size_BVALID == 1'b0) | (1'b1 == ap_block_state26_io)) & (1'b1 == ap_CS_fsm_state26)) | ((1'b1 == ap_CS_fsm_state18) & (m_axi_size_AWREADY == 1'b1)))) begin
        reg_987 <= dest_array_q1;
    end else if (((1'b1 == ap_CS_fsm_state3) | ((1'b1 == ap_CS_fsm_state41) & (m_axi_size_BVALID == 1'b1)))) begin
        reg_987 <= dest_array_q0;
    end
end

always @ (posedge ap_clk) begin
    if ((~((m_axi_size_BVALID == 1'b0) & (icmp_ln83_reg_1855 == 1'd1)) & (icmp_ln115_fu_1442_p2 == 1'd1) & (1'b1 == ap_CS_fsm_state78))) begin
        add_ln116_reg_1881 <= add_ln116_fu_1451_p2;
    end
end

always @ (posedge ap_clk) begin
    if (((icmp_ln12_fu_1018_p2 == 1'd1) & (1'b1 == ap_CS_fsm_state3))) begin
        add_ln13_reg_1581 <= add_ln13_fu_1027_p2;
    end
end

always @ (posedge ap_clk) begin
    if ((~((m_axi_size_BVALID == 1'b0) & (icmp_ln115_reg_1877 == 1'd1)) & (icmp_ln145_fu_1467_p2 == 1'd1) & (1'b1 == ap_CS_fsm_state92))) begin
        add_ln146_reg_1903 <= add_ln146_fu_1476_p2;
    end
end

always @ (posedge ap_clk) begin
    if ((~((m_axi_size_BVALID == 1'b0) & (icmp_ln145_reg_1899 == 1'd1)) & (icmp_ln167_fu_1492_p2 == 1'd1) & (1'b1 == ap_CS_fsm_state104))) begin
        add_ln168_reg_1923 <= add_ln168_fu_1501_p2;
    end
end

always @ (posedge ap_clk) begin
    if ((~((m_axi_size_BVALID == 1'b0) & (icmp_ln12_reg_1577 == 1'd1)) & (icmp_ln15_fu_1043_p2 == 1'd1) & (1'b1 == ap_CS_fsm_state10))) begin
        add_ln16_reg_1596 <= add_ln16_fu_1052_p2;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_state21_io) & (1'b1 == ap_CS_fsm_state21))) begin
        add_ln21_3_reg_1664 <= add_ln21_3_fu_1120_p2;
        dest_array_load_11_reg_1656 <= dest_array_q1;
        dest_array_load_16_reg_1669 <= dest_array_q0;
    end
end

always @ (posedge ap_clk) begin
    if ((~((m_axi_size_BVALID == 1'b0) & (icmp_ln15_reg_1592 == 1'd1)) & (1'b1 == ap_CS_fsm_state17))) begin
        add_ln21_reg_1617 <= add_ln21_fu_1071_p2;
        zext_ln21_reg_1612[29 : 0] <= zext_ln21_fu_1068_p1[29 : 0];
    end
end

always @ (posedge ap_clk) begin
    if ((~((m_axi_size_BVALID == 1'b0) | (1'b1 == ap_block_state26_io)) & (1'b1 == ap_CS_fsm_state26))) begin
        add_ln24_2_reg_1760 <= add_ln24_2_fu_1246_p2;
        add_ln27_5_reg_1771 <= add_ln27_5_fu_1265_p2;
    end
end

always @ (posedge ap_clk) begin
    if ((~((m_axi_size_BVALID == 1'b0) | (1'b1 == ap_block_state25_io)) & (1'b1 == ap_CS_fsm_state25))) begin
        add_ln24_5_reg_1735 <= add_ln24_5_fu_1179_p2;
        dest_array_load_12_reg_1740 <= dest_array_q1;
        dest_array_load_13_reg_1745 <= dest_array_q0;
    end
end

always @ (posedge ap_clk) begin
    if ((~((m_axi_size_BVALID == 1'b0) | (1'b1 == ap_block_state27_io)) & (1'b1 == ap_CS_fsm_state27))) begin
        add_ln27_2_reg_1776 <= add_ln27_2_fu_1321_p2;
    end
end

always @ (posedge ap_clk) begin
    if (((icmp_ln37_fu_1342_p2 == 1'd1) & (1'b1 == ap_CS_fsm_state34))) begin
        add_ln38_reg_1800 <= add_ln38_fu_1351_p2;
    end
end

always @ (posedge ap_clk) begin
    if (((icmp_ln39_fu_1367_p2 == 1'd1) & (1'b1 == ap_CS_fsm_state41) & (m_axi_size_BVALID == 1'b1))) begin
        add_ln40_reg_1820 <= add_ln40_fu_1376_p2;
    end
end

always @ (posedge ap_clk) begin
    if ((~((m_axi_size_BVALID == 1'b0) & (icmp_ln39_reg_1816 == 1'd1)) & (icmp_ln59_fu_1392_p2 == 1'd1) & (1'b1 == ap_CS_fsm_state52))) begin
        add_ln60_reg_1839 <= add_ln60_fu_1401_p2;
    end
end

always @ (posedge ap_clk) begin
    if ((~((m_axi_size_BVALID == 1'b0) & (icmp_ln59_reg_1835 == 1'd1)) & (icmp_ln83_fu_1417_p2 == 1'd1) & (1'b1 == ap_CS_fsm_state64))) begin
        add_ln84_reg_1859 <= add_ln84_fu_1426_p2;
    end
end

always @ (posedge ap_clk) begin
    if ((~((m_axi_size_BVALID == 1'b0) | (1'b1 == ap_block_state24_io)) & (1'b1 == ap_CS_fsm_state24))) begin
        dest_array_load_6_reg_1715 <= dest_array_q1;
        dest_array_load_7_reg_1720 <= dest_array_q0;
    end
end

always @ (posedge ap_clk) begin
    if ((~((m_axi_size_BVALID == 1'b0) & (icmp_ln83_reg_1855 == 1'd1)) & (1'b1 == ap_CS_fsm_state78))) begin
        icmp_ln115_reg_1877 <= icmp_ln115_fu_1442_p2;
    end
end

always @ (posedge ap_clk) begin
    if ((1'b1 == ap_CS_fsm_state2)) begin
        icmp_ln11_reg_1568 <= icmp_ln11_fu_1012_p2;
        tmp_reg_1563 <= tmp_fu_1004_p3;
    end
end

always @ (posedge ap_clk) begin
    if ((1'b1 == ap_CS_fsm_state3)) begin
        icmp_ln12_reg_1577 <= icmp_ln12_fu_1018_p2;
    end
end

always @ (posedge ap_clk) begin
    if ((~((m_axi_size_BVALID == 1'b0) & (icmp_ln115_reg_1877 == 1'd1)) & (1'b1 == ap_CS_fsm_state92))) begin
        icmp_ln145_reg_1899 <= icmp_ln145_fu_1467_p2;
    end
end

always @ (posedge ap_clk) begin
    if ((~((m_axi_size_BVALID == 1'b0) & (icmp_ln12_reg_1577 == 1'd1)) & (1'b1 == ap_CS_fsm_state10))) begin
        icmp_ln15_reg_1592 <= icmp_ln15_fu_1043_p2;
    end
end

always @ (posedge ap_clk) begin
    if ((~((m_axi_size_BVALID == 1'b0) & (icmp_ln145_reg_1899 == 1'd1)) & (1'b1 == ap_CS_fsm_state104))) begin
        icmp_ln167_reg_1919 <= icmp_ln167_fu_1492_p2;
    end
end

always @ (posedge ap_clk) begin
    if ((~((m_axi_size_BVALID == 1'b0) & (icmp_ln11_reg_1568 == 1'd1)) & (1'b1 == ap_CS_fsm_state33))) begin
        icmp_ln36_reg_1787 <= icmp_ln36_fu_1337_p2;
    end
end

always @ (posedge ap_clk) begin
    if ((1'b1 == ap_CS_fsm_state34)) begin
        icmp_ln37_reg_1796 <= icmp_ln37_fu_1342_p2;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b1 == ap_CS_fsm_state41) & (m_axi_size_BVALID == 1'b1))) begin
        icmp_ln39_reg_1816 <= icmp_ln39_fu_1367_p2;
    end
end

always @ (posedge ap_clk) begin
    if ((~((m_axi_size_BVALID == 1'b0) & (icmp_ln39_reg_1816 == 1'd1)) & (1'b1 == ap_CS_fsm_state52))) begin
        icmp_ln59_reg_1835 <= icmp_ln59_fu_1392_p2;
    end
end

always @ (posedge ap_clk) begin
    if ((~((m_axi_size_BVALID == 1'b0) & (icmp_ln59_reg_1835 == 1'd1)) & (1'b1 == ap_CS_fsm_state64))) begin
        icmp_ln83_reg_1855 <= icmp_ln83_fu_1417_p2;
    end
end

always @ (posedge ap_clk) begin
    if ((((1'b0 == ap_block_state23_io) & (1'b1 == ap_CS_fsm_state23)) | ((1'b0 == ap_block_state20_io) & (1'b1 == ap_CS_fsm_state20)))) begin
        reg_1000 <= dest_array_q0;
        reg_996 <= dest_array_q1;
    end
end

always @ (posedge ap_clk) begin
    if ((((1'b0 == ap_block_state22_io) & (1'b1 == ap_CS_fsm_state22)) | (~((m_axi_size_BVALID == 1'b0) | (1'b1 == ap_block_state26_io)) & (1'b1 == ap_CS_fsm_state26)) | ((1'b0 == ap_block_state19_io) & (1'b1 == ap_CS_fsm_state19)))) begin
        reg_992 <= dest_array_q0;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b1 == ap_CS_fsm_state18) & (m_axi_size_AWREADY == 1'b1))) begin
        size_addr_26_reg_1622[30 : 0] <= zext_ln21_17_fu_1077_p1[30 : 0];
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_state22_io) & (1'b1 == ap_CS_fsm_state22))) begin
        size_addr_27_reg_1686[30 : 0] <= zext_ln21_21_fu_1138_p1[30 : 0];
    end
end

always @ (*) begin
    if (((~((m_axi_size_BVALID == 1'b0) & (ap_predicate_op469_writeresp_state115 == 1'b1)) & (1'b1 == ap_CS_fsm_state115)) | ((ap_start == 1'b0) & (1'b1 == ap_CS_fsm_state1)))) begin
        ap_done = 1'b1;
    end else begin
        ap_done = 1'b0;
    end
end

always @ (*) begin
    if (((ap_start == 1'b0) & (1'b1 == ap_CS_fsm_state1))) begin
        ap_idle = 1'b1;
    end else begin
        ap_idle = 1'b0;
    end
end

always @ (*) begin
    if ((~((m_axi_size_BVALID == 1'b0) & (ap_predicate_op469_writeresp_state115 == 1'b1)) & (1'b1 == ap_CS_fsm_state115))) begin
        ap_ready = 1'b1;
    end else begin
        ap_ready = 1'b0;
    end
end

always @ (*) begin
    if ((1'b1 == ap_CS_fsm_state40)) begin
        dest_array_address0 = 64'd85;
    end else if ((1'b1 == ap_CS_fsm_state25)) begin
        dest_array_address0 = 64'd106;
    end else if ((1'b1 == ap_CS_fsm_state24)) begin
        dest_array_address0 = 64'd108;
    end else if ((1'b1 == ap_CS_fsm_state23)) begin
        dest_array_address0 = 64'd102;
    end else if ((1'b1 == ap_CS_fsm_state22)) begin
        dest_array_address0 = 64'd104;
    end else if ((1'b1 == ap_CS_fsm_state21)) begin
        dest_array_address0 = 64'd101;
    end else if ((1'b1 == ap_CS_fsm_state20)) begin
        dest_array_address0 = 64'd99;
    end else if ((1'b1 == ap_CS_fsm_state19)) begin
        dest_array_address0 = 64'd97;
    end else if ((1'b1 == ap_CS_fsm_state18)) begin
        dest_array_address0 = 64'd95;
    end else if ((1'b1 == ap_CS_fsm_state2)) begin
        dest_array_address0 = 64'd84;
    end else if ((1'b1 == ap_CS_fsm_state1)) begin
        dest_array_address0 = 64'd38;
    end else begin
        dest_array_address0 = 'bx;
    end
end

always @ (*) begin
    if ((1'b1 == ap_CS_fsm_state33)) begin
        dest_array_address1 = 64'd84;
    end else if ((1'b1 == ap_CS_fsm_state25)) begin
        dest_array_address1 = 64'd107;
    end else if ((1'b1 == ap_CS_fsm_state24)) begin
        dest_array_address1 = 64'd109;
    end else if ((1'b1 == ap_CS_fsm_state23)) begin
        dest_array_address1 = 64'd103;
    end else if ((1'b1 == ap_CS_fsm_state22)) begin
        dest_array_address1 = 64'd105;
    end else if ((1'b1 == ap_CS_fsm_state21)) begin
        dest_array_address1 = 64'd100;
    end else if ((1'b1 == ap_CS_fsm_state20)) begin
        dest_array_address1 = 64'd98;
    end else if ((1'b1 == ap_CS_fsm_state19)) begin
        dest_array_address1 = 64'd96;
    end else if ((1'b1 == ap_CS_fsm_state17)) begin
        dest_array_address1 = 64'd94;
    end else if ((1'b1 == ap_CS_fsm_state1)) begin
        dest_array_address1 = 64'd39;
    end else begin
        dest_array_address1 = 'bx;
    end
end

always @ (*) begin
    if (((1'b1 == ap_CS_fsm_state40) | (1'b1 == ap_CS_fsm_state2) | ((1'b0 == ap_block_state23_io) & (1'b1 == ap_CS_fsm_state23)) | ((1'b0 == ap_block_state22_io) & (1'b1 == ap_CS_fsm_state22)) | ((1'b0 == ap_block_state21_io) & (1'b1 == ap_CS_fsm_state21)) | (~((m_axi_size_BVALID == 1'b0) | (1'b1 == ap_block_state25_io)) & (1'b1 == ap_CS_fsm_state25)) | ((1'b0 == ap_block_state20_io) & (1'b1 == ap_CS_fsm_state20)) | (~((m_axi_size_BVALID == 1'b0) | (1'b1 == ap_block_state24_io)) & (1'b1 == ap_CS_fsm_state24)) | ((1'b0 == ap_block_state19_io) & (1'b1 == ap_CS_fsm_state19)) | ((1'b1 == ap_CS_fsm_state18) & (m_axi_size_AWREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state1) & (ap_start == 1'b1)))) begin
        dest_array_ce0 = 1'b1;
    end else begin
        dest_array_ce0 = 1'b0;
    end
end

always @ (*) begin
    if (((~((m_axi_size_BVALID == 1'b0) & (icmp_ln11_reg_1568 == 1'd1)) & (1'b1 == ap_CS_fsm_state33)) | ((1'b0 == ap_block_state23_io) & (1'b1 == ap_CS_fsm_state23)) | ((1'b0 == ap_block_state22_io) & (1'b1 == ap_CS_fsm_state22)) | ((1'b0 == ap_block_state21_io) & (1'b1 == ap_CS_fsm_state21)) | (~((m_axi_size_BVALID == 1'b0) | (1'b1 == ap_block_state25_io)) & (1'b1 == ap_CS_fsm_state25)) | ((1'b0 == ap_block_state20_io) & (1'b1 == ap_CS_fsm_state20)) | (~((m_axi_size_BVALID == 1'b0) | (1'b1 == ap_block_state24_io)) & (1'b1 == ap_CS_fsm_state24)) | ((1'b0 == ap_block_state19_io) & (1'b1 == ap_CS_fsm_state19)) | (~((m_axi_size_BVALID == 1'b0) & (icmp_ln15_reg_1592 == 1'd1)) & (1'b1 == ap_CS_fsm_state17)) | ((1'b1 == ap_CS_fsm_state1) & (ap_start == 1'b1)))) begin
        dest_array_ce1 = 1'b1;
    end else begin
        dest_array_ce1 = 1'b0;
    end
end

always @ (*) begin
    if (((1'b1 == ap_CS_fsm_state105) & (m_axi_size_AWREADY == 1'b1))) begin
        m_axi_size_AWADDR = zext_ln168_3_fu_1507_p1;
    end else if (((1'b1 == ap_CS_fsm_state93) & (m_axi_size_AWREADY == 1'b1))) begin
        m_axi_size_AWADDR = zext_ln146_3_fu_1482_p1;
    end else if (((1'b1 == ap_CS_fsm_state79) & (m_axi_size_AWREADY == 1'b1))) begin
        m_axi_size_AWADDR = zext_ln116_3_fu_1457_p1;
    end else if (((1'b1 == ap_CS_fsm_state65) & (m_axi_size_AWREADY == 1'b1))) begin
        m_axi_size_AWADDR = zext_ln84_3_fu_1432_p1;
    end else if (((1'b1 == ap_CS_fsm_state53) & (m_axi_size_AWREADY == 1'b1))) begin
        m_axi_size_AWADDR = zext_ln60_3_fu_1407_p1;
    end else if (((1'b1 == ap_CS_fsm_state42) & (m_axi_size_AWREADY == 1'b1))) begin
        m_axi_size_AWADDR = zext_ln40_3_fu_1382_p1;
    end else if (((1'b1 == ap_CS_fsm_state35) & (m_axi_size_AWREADY == 1'b1))) begin
        m_axi_size_AWADDR = zext_ln38_3_fu_1357_p1;
    end else if ((~((m_axi_size_BVALID == 1'b0) | (1'b1 == ap_block_state27_io)) & (1'b1 == ap_CS_fsm_state27))) begin
        m_axi_size_AWADDR = zext_ln27_3_fu_1327_p1;
    end else if ((~((m_axi_size_BVALID == 1'b0) | (1'b1 == ap_block_state26_io)) & (1'b1 == ap_CS_fsm_state26))) begin
        m_axi_size_AWADDR = zext_ln24_3_fu_1252_p1;
    end else if ((((1'b0 == ap_block_state23_io) & (1'b1 == ap_CS_fsm_state23)) | (~((m_axi_size_BVALID == 1'b0) | (1'b1 == ap_block_state25_io)) & (1'b1 == ap_CS_fsm_state25)) | (~((m_axi_size_BVALID == 1'b0) | (1'b1 == ap_block_state24_io)) & (1'b1 == ap_CS_fsm_state24)))) begin
        m_axi_size_AWADDR = size_addr_27_reg_1686;
    end else if (((1'b0 == ap_block_state22_io) & (1'b1 == ap_CS_fsm_state22))) begin
        m_axi_size_AWADDR = zext_ln21_21_fu_1138_p1;
    end else if ((((1'b0 == ap_block_state21_io) & (1'b1 == ap_CS_fsm_state21)) | ((1'b0 == ap_block_state20_io) & (1'b1 == ap_CS_fsm_state20)) | ((1'b0 == ap_block_state19_io) & (1'b1 == ap_CS_fsm_state19)))) begin
        m_axi_size_AWADDR = size_addr_26_reg_1622;
    end else if (((1'b1 == ap_CS_fsm_state18) & (m_axi_size_AWREADY == 1'b1))) begin
        m_axi_size_AWADDR = zext_ln21_17_fu_1077_p1;
    end else if (((1'b1 == ap_CS_fsm_state11) & (m_axi_size_AWREADY == 1'b1))) begin
        m_axi_size_AWADDR = zext_ln16_3_fu_1058_p1;
    end else if (((1'b1 == ap_CS_fsm_state4) & (m_axi_size_AWREADY == 1'b1))) begin
        m_axi_size_AWADDR = zext_ln13_3_fu_1033_p1;
    end else begin
        m_axi_size_AWADDR = 'bx;
    end
end

always @ (*) begin
    if ((((1'b1 == ap_CS_fsm_state79) & (m_axi_size_AWREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state65) & (m_axi_size_AWREADY == 1'b1)))) begin
        m_axi_size_AWLEN = 32'd8;
    end else if ((((1'b1 == ap_CS_fsm_state93) & (m_axi_size_AWREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state53) & (m_axi_size_AWREADY == 1'b1)))) begin
        m_axi_size_AWLEN = 32'd6;
    end else if ((((1'b1 == ap_CS_fsm_state105) & (m_axi_size_AWREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state42) & (m_axi_size_AWREADY == 1'b1)))) begin
        m_axi_size_AWLEN = 32'd5;
    end else if ((((1'b1 == ap_CS_fsm_state35) & (m_axi_size_AWREADY == 1'b1)) | ((1'b0 == ap_block_state23_io) & (1'b1 == ap_CS_fsm_state23)) | (~((m_axi_size_BVALID == 1'b0) | (1'b1 == ap_block_state27_io)) & (1'b1 == ap_CS_fsm_state27)) | ((1'b0 == ap_block_state22_io) & (1'b1 == ap_CS_fsm_state22)) | (~((m_axi_size_BVALID == 1'b0) | (1'b1 == ap_block_state26_io)) & (1'b1 == ap_CS_fsm_state26)) | ((1'b0 == ap_block_state21_io) & (1'b1 == ap_CS_fsm_state21)) | (~((m_axi_size_BVALID == 1'b0) | (1'b1 == ap_block_state25_io)) & (1'b1 == ap_CS_fsm_state25)) | ((1'b0 == ap_block_state20_io) & (1'b1 == ap_CS_fsm_state20)) | (~((m_axi_size_BVALID == 1'b0) | (1'b1 == ap_block_state24_io)) & (1'b1 == ap_CS_fsm_state24)) | ((1'b0 == ap_block_state19_io) & (1'b1 == ap_CS_fsm_state19)) | ((1'b1 == ap_CS_fsm_state18) & (m_axi_size_AWREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state11) & (m_axi_size_AWREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state4) & (m_axi_size_AWREADY == 1'b1)))) begin
        m_axi_size_AWLEN = 32'd1;
    end else begin
        m_axi_size_AWLEN = 'bx;
    end
end

always @ (*) begin
    if ((((1'b1 == ap_CS_fsm_state105) & (m_axi_size_AWREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state93) & (m_axi_size_AWREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state79) & (m_axi_size_AWREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state65) & (m_axi_size_AWREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state53) & (m_axi_size_AWREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state42) & (m_axi_size_AWREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state35) & (m_axi_size_AWREADY == 1'b1)) | ((1'b0 == ap_block_state23_io) & (1'b1 == ap_CS_fsm_state23)) | (~((m_axi_size_BVALID == 1'b0) | (1'b1 == ap_block_state27_io)) & (1'b1 == ap_CS_fsm_state27)) | ((1'b0 == ap_block_state22_io) & (1'b1 == ap_CS_fsm_state22)) | (~((m_axi_size_BVALID == 1'b0) | (1'b1 == ap_block_state26_io)) & (1'b1 == ap_CS_fsm_state26)) | ((1'b0 == ap_block_state21_io) & (1'b1 == ap_CS_fsm_state21)) | (~((m_axi_size_BVALID == 1'b0) | (1'b1 == ap_block_state25_io)) & (1'b1 == ap_CS_fsm_state25)) | ((1'b0 == ap_block_state20_io) & (1'b1 == ap_CS_fsm_state20)) | (~((m_axi_size_BVALID == 1'b0) | (1'b1 == ap_block_state24_io)) & (1'b1 == ap_CS_fsm_state24)) | ((1'b0 == ap_block_state19_io) & (1'b1 == ap_CS_fsm_state19)) | ((1'b1 == ap_CS_fsm_state18) & (m_axi_size_AWREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state11) & (m_axi_size_AWREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state4) & (m_axi_size_AWREADY == 1'b1)))) begin
        m_axi_size_AWVALID = 1'b1;
    end else begin
        m_axi_size_AWVALID = 1'b0;
    end
end

always @ (*) begin
    if (((~((m_axi_size_BVALID == 1'b0) & (ap_predicate_op469_writeresp_state115 == 1'b1)) & (1'b1 == ap_CS_fsm_state115) & (ap_predicate_op469_writeresp_state115 == 1'b1)) | (~((m_axi_size_BVALID == 1'b0) & (icmp_ln145_reg_1899 == 1'd1)) & (icmp_ln145_reg_1899 == 1'd1) & (1'b1 == ap_CS_fsm_state104)) | (~((m_axi_size_BVALID == 1'b0) & (icmp_ln115_reg_1877 == 1'd1)) & (icmp_ln115_reg_1877 == 1'd1) & (1'b1 == ap_CS_fsm_state92)) | (~((m_axi_size_BVALID == 1'b0) & (icmp_ln83_reg_1855 == 1'd1)) & (icmp_ln83_reg_1855 == 1'd1) & (1'b1 == ap_CS_fsm_state78)) | (~((m_axi_size_BVALID == 1'b0) & (icmp_ln59_reg_1835 == 1'd1)) & (icmp_ln59_reg_1835 == 1'd1) & (1'b1 == ap_CS_fsm_state64)) | (~((m_axi_size_BVALID == 1'b0) & (icmp_ln39_reg_1816 == 1'd1)) & (icmp_ln39_reg_1816 == 1'd1) & (1'b1 == ap_CS_fsm_state52)) | ((1'b1 == ap_CS_fsm_state41) & (m_axi_size_BVALID == 1'b1)) | (~((m_axi_size_BVALID == 1'b0) & (icmp_ln11_reg_1568 == 1'd1)) & (icmp_ln11_reg_1568 == 1'd1) & (1'b1 == ap_CS_fsm_state33)) | ((1'b1 == ap_CS_fsm_state32) & (m_axi_size_BVALID == 1'b1)) | ((1'b1 == ap_CS_fsm_state31) & (m_axi_size_BVALID == 1'b1)) | ((1'b1 == ap_CS_fsm_state30) & (m_axi_size_BVALID == 1'b1)) | ((1'b1 == ap_CS_fsm_state29) & (m_axi_size_BVALID == 1'b1)) | (~((m_axi_size_BVALID == 1'b0) | (m_axi_size_WREADY == 1'b0)) & (1'b1 == ap_CS_fsm_state28)) | (~((m_axi_size_BVALID == 1'b0) | (1'b1 == ap_block_state27_io)) & (1'b1 == ap_CS_fsm_state27)) | (~((m_axi_size_BVALID == 1'b0) | (1'b1 == ap_block_state26_io)) & (1'b1 == ap_CS_fsm_state26)) | (~((m_axi_size_BVALID == 1'b0) | (1'b1 == ap_block_state25_io)) & (1'b1 == ap_CS_fsm_state25)) | (~((m_axi_size_BVALID == 1'b0) | (1'b1 == ap_block_state24_io)) & (1'b1 == ap_CS_fsm_state24)) | (~((m_axi_size_BVALID == 1'b0) & (icmp_ln15_reg_1592 == 1'd1)) & (icmp_ln15_reg_1592 == 1'd1) & (1'b1 == ap_CS_fsm_state17)) | (~((m_axi_size_BVALID == 1'b0) & (icmp_ln12_reg_1577 == 1'd1)) & (icmp_ln12_reg_1577 == 1'd1) & (1'b1 == ap_CS_fsm_state10)))) begin
        m_axi_size_BREADY = 1'b1;
    end else begin
        m_axi_size_BREADY = 1'b0;
    end
end

always @ (*) begin
    if ((1'b1 == ap_CS_fsm_state109)) begin
        m_axi_size_WDATA = 32'd1701273971;
    end else if ((1'b1 == ap_CS_fsm_state108)) begin
        m_axi_size_WDATA = 32'd1936026912;
    end else if ((1'b1 == ap_CS_fsm_state97)) begin
        m_axi_size_WDATA = 32'd544040308;
    end else if ((1'b1 == ap_CS_fsm_state96)) begin
        m_axi_size_WDATA = 32'd1937339168;
    end else if (((1'b1 == ap_CS_fsm_state110) | (1'b1 == ap_CS_fsm_state99) | (1'b1 == ap_CS_fsm_state87))) begin
        m_axi_size_WDATA = 32'd115;
    end else if (((1'b1 == ap_CS_fsm_state98) | (1'b1 == ap_CS_fsm_state86))) begin
        m_axi_size_WDATA = 32'd1920298856;
    end else if ((1'b1 == ap_CS_fsm_state85)) begin
        m_axi_size_WDATA = 32'd544499051;
    end else if ((1'b1 == ap_CS_fsm_state84)) begin
        m_axi_size_WDATA = 32'd1918987552;
    end else if ((1'b1 == ap_CS_fsm_state83)) begin
        m_axi_size_WDATA = 32'd1918987381;
    end else if ((1'b1 == ap_CS_fsm_state82)) begin
        m_axi_size_WDATA = 32'd1734701600;
    end else if (((1'b1 == ap_CS_fsm_state107) | (1'b1 == ap_CS_fsm_state95) | (1'b1 == ap_CS_fsm_state81))) begin
        m_axi_size_WDATA = 32'd1718558820;
    end else if (((1'b1 == ap_CS_fsm_state106) | (1'b1 == ap_CS_fsm_state94) | (1'b1 == ap_CS_fsm_state80))) begin
        m_axi_size_WDATA = 32'd1852112896;
    end else if ((1'b1 == ap_CS_fsm_state73)) begin
        m_axi_size_WDATA = 32'd7565941;
    end else if ((1'b1 == ap_CS_fsm_state72)) begin
        m_axi_size_WDATA = 32'd1869095028;
    end else if ((1'b1 == ap_CS_fsm_state71)) begin
        m_axi_size_WDATA = 32'd1701540449;
    end else if ((1'b1 == ap_CS_fsm_state70)) begin
        m_axi_size_WDATA = 32'd1830842977;
    end else if ((1'b1 == ap_CS_fsm_state69)) begin
        m_axi_size_WDATA = 32'd1819633509;
    end else if ((1'b1 == ap_CS_fsm_state68)) begin
        m_axi_size_WDATA = 32'd1914725999;
    end else if ((1'b1 == ap_CS_fsm_state59)) begin
        m_axi_size_WDATA = 32'd812872309;
    end else if ((1'b1 == ap_CS_fsm_state58)) begin
        m_axi_size_WDATA = 32'd1869095021;
    end else if ((1'b1 == ap_CS_fsm_state57)) begin
        m_axi_size_WDATA = 32'd1702130553;
    end else if ((1'b1 == ap_CS_fsm_state56)) begin
        m_axi_size_WDATA = 32'd1931503215;
    end else if ((1'b1 == ap_CS_fsm_state47)) begin
        m_axi_size_WDATA = 32'd7562599;
    end else if ((1'b1 == ap_CS_fsm_state46)) begin
        m_axi_size_WDATA = 32'd1634956133;
    end else if ((1'b1 == ap_CS_fsm_state45)) begin
        m_axi_size_WDATA = 32'd1830839919;
    end else if (((1'b1 == ap_CS_fsm_state67) | (1'b1 == ap_CS_fsm_state55) | (1'b1 == ap_CS_fsm_state44))) begin
        m_axi_size_WDATA = 32'd544502369;
    end else if (((1'b1 == ap_CS_fsm_state66) | (1'b1 == ap_CS_fsm_state54) | (1'b1 == ap_CS_fsm_state43))) begin
        m_axi_size_WDATA = 32'd1953693696;
    end else if (((1'b1 == ap_CS_fsm_state28) & (m_axi_size_BVALID == 1'b1))) begin
        m_axi_size_WDATA = add_ln27_2_reg_1776;
    end else if (((1'b1 == ap_CS_fsm_state27) & (m_axi_size_BVALID == 1'b1))) begin
        m_axi_size_WDATA = add_ln24_2_reg_1760;
    end else if (((1'b1 == ap_CS_fsm_state26) & (m_axi_size_BVALID == 1'b1))) begin
        m_axi_size_WDATA = tmp_2_fu_1185_p5;
    end else if (((1'b1 == ap_CS_fsm_state25) & (m_axi_size_BVALID == 1'b1))) begin
        m_axi_size_WDATA = zext_ln21_24_fu_1171_p1;
    end else if (((1'b1 == ap_CS_fsm_state24) & (m_axi_size_BVALID == 1'b1))) begin
        m_axi_size_WDATA = zext_ln21_23_fu_1158_p1;
    end else if ((1'b1 == ap_CS_fsm_state23)) begin
        m_axi_size_WDATA = zext_ln21_22_fu_1148_p1;
    end else if ((1'b1 == ap_CS_fsm_state22)) begin
        m_axi_size_WDATA = tmp_s_fu_1125_p5;
    end else if ((1'b1 == ap_CS_fsm_state21)) begin
        m_axi_size_WDATA = zext_ln21_20_fu_1115_p1;
    end else if ((1'b1 == ap_CS_fsm_state20)) begin
        m_axi_size_WDATA = zext_ln21_19_fu_1100_p1;
    end else if ((1'b1 == ap_CS_fsm_state19)) begin
        m_axi_size_WDATA = zext_ln21_18_fu_1087_p1;
    end else if ((1'b1 == ap_CS_fsm_state12)) begin
        m_axi_size_WDATA = 32'd0;
    end else if (((1'b1 == ap_CS_fsm_state36) | (1'b1 == ap_CS_fsm_state5))) begin
        m_axi_size_WDATA = 32'd1;
    end else begin
        m_axi_size_WDATA = 'bx;
    end
end

always @ (*) begin
    if (((1'b1 == ap_CS_fsm_state110) | (1'b1 == ap_CS_fsm_state99) | (1'b1 == ap_CS_fsm_state87))) begin
        m_axi_size_WSTRB = 4'd3;
    end else if (((1'b1 == ap_CS_fsm_state106) | (1'b1 == ap_CS_fsm_state94) | (1'b1 == ap_CS_fsm_state80) | (1'b1 == ap_CS_fsm_state66) | (1'b1 == ap_CS_fsm_state54) | (1'b1 == ap_CS_fsm_state43))) begin
        m_axi_size_WSTRB = 4'd12;
    end else if (((1'b1 == ap_CS_fsm_state23) | (1'b1 == ap_CS_fsm_state19))) begin
        m_axi_size_WSTRB = 4'd1;
    end else if (((1'b1 == ap_CS_fsm_state109) | (1'b1 == ap_CS_fsm_state108) | (1'b1 == ap_CS_fsm_state107) | (1'b1 == ap_CS_fsm_state98) | (1'b1 == ap_CS_fsm_state97) | (1'b1 == ap_CS_fsm_state96) | (1'b1 == ap_CS_fsm_state95) | (1'b1 == ap_CS_fsm_state86) | (1'b1 == ap_CS_fsm_state85) | (1'b1 == ap_CS_fsm_state84) | (1'b1 == ap_CS_fsm_state83) | (1'b1 == ap_CS_fsm_state82) | (1'b1 == ap_CS_fsm_state81) | (1'b1 == ap_CS_fsm_state73) | (1'b1 == ap_CS_fsm_state72) | (1'b1 == ap_CS_fsm_state71) | (1'b1 == ap_CS_fsm_state70) | (1'b1 == ap_CS_fsm_state69) | (1'b1 == ap_CS_fsm_state68) | (1'b1 == ap_CS_fsm_state67) | (1'b1 == ap_CS_fsm_state59) | (1'b1 == ap_CS_fsm_state58) | (1'b1 == ap_CS_fsm_state57) | (1'b1 == ap_CS_fsm_state56) | (1'b1 == ap_CS_fsm_state55) | (1'b1 == ap_CS_fsm_state47) | (1'b1 == ap_CS_fsm_state46) | (1'b1 == ap_CS_fsm_state45) | (1'b1 == ap_CS_fsm_state44) | (1'b1 == ap_CS_fsm_state36) | (1'b1 == ap_CS_fsm_state22) | (1'b1 == ap_CS_fsm_state21) | (1'b1 == ap_CS_fsm_state20) | (1'b1 == ap_CS_fsm_state12) | (1'b1 == ap_CS_fsm_state5) | ((1'b1 == ap_CS_fsm_state28) & (m_axi_size_BVALID == 1'b1)) | ((1'b1 == ap_CS_fsm_state27) & (m_axi_size_BVALID == 1'b1)) | ((1'b1 == ap_CS_fsm_state26) & (m_axi_size_BVALID == 1'b1)) | ((1'b1 == ap_CS_fsm_state25) & (m_axi_size_BVALID == 1'b1)) | ((1'b1 == ap_CS_fsm_state24) & (m_axi_size_BVALID == 1'b1)))) begin
        m_axi_size_WSTRB = 4'd15;
    end else begin
        m_axi_size_WSTRB = 'bx;
    end
end

always @ (*) begin
    if ((((1'b1 == ap_CS_fsm_state110) & (m_axi_size_WREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state109) & (m_axi_size_WREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state108) & (m_axi_size_WREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state107) & (m_axi_size_WREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state106) & (m_axi_size_WREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state99) & (m_axi_size_WREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state98) & (m_axi_size_WREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state97) & (m_axi_size_WREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state96) & (m_axi_size_WREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state95) & (m_axi_size_WREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state94) & (m_axi_size_WREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state87) & (m_axi_size_WREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state86) & (m_axi_size_WREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state85) & (m_axi_size_WREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state84) & (m_axi_size_WREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state83) & (m_axi_size_WREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state82) & (m_axi_size_WREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state81) & (m_axi_size_WREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state80) & (m_axi_size_WREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state73) & (m_axi_size_WREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state72) & (m_axi_size_WREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state71) & (m_axi_size_WREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state70) & (m_axi_size_WREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state69) & (m_axi_size_WREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state68) & (m_axi_size_WREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state67) & (m_axi_size_WREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state66) & (m_axi_size_WREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state59) & (m_axi_size_WREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state58) & (m_axi_size_WREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state57) & (m_axi_size_WREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state56) & (m_axi_size_WREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state55) & (m_axi_size_WREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state54) & (m_axi_size_WREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state47) & (m_axi_size_WREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state46) & (m_axi_size_WREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state45) & (m_axi_size_WREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state44) & (m_axi_size_WREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state43) & (m_axi_size_WREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state36) & (m_axi_size_WREADY == 1'b1)) | (~((m_axi_size_BVALID == 1'b0) | (m_axi_size_WREADY == 1'b0)) & (1'b1 == ap_CS_fsm_state28)) | ((1'b0 == ap_block_state23_io) & (1'b1 == ap_CS_fsm_state23)) | (~((m_axi_size_BVALID == 1'b0) | (1'b1 == ap_block_state27_io)) & (1'b1 == ap_CS_fsm_state27)) | ((1'b0 == ap_block_state22_io) & (1'b1 == ap_CS_fsm_state22)) | (~((m_axi_size_BVALID == 1'b0) | (1'b1 == ap_block_state26_io)) & (1'b1 == ap_CS_fsm_state26)) | ((1'b0 == ap_block_state21_io) & (1'b1 == ap_CS_fsm_state21)) | (~((m_axi_size_BVALID == 1'b0) | (1'b1 == ap_block_state25_io)) & (1'b1 == ap_CS_fsm_state25)) | ((1'b0 == ap_block_state20_io) & (1'b1 == ap_CS_fsm_state20)) | (~((m_axi_size_BVALID == 1'b0) | (1'b1 == ap_block_state24_io)) & (1'b1 == ap_CS_fsm_state24)) | ((1'b0 == ap_block_state19_io) & (1'b1 == ap_CS_fsm_state19)) | ((1'b1 == ap_CS_fsm_state12) & (m_axi_size_WREADY == 1'b1)) | ((1'b1 == ap_CS_fsm_state5) & (m_axi_size_WREADY == 1'b1)))) begin
        m_axi_size_WVALID = 1'b1;
    end else begin
        m_axi_size_WVALID = 1'b0;
    end
end

always @ (*) begin
    if (((1'b1 == ap_CS_fsm_state105) | (1'b1 == ap_CS_fsm_state93) | (1'b1 == ap_CS_fsm_state79) | (1'b1 == ap_CS_fsm_state65) | (1'b1 == ap_CS_fsm_state53) | (1'b1 == ap_CS_fsm_state42) | (1'b1 == ap_CS_fsm_state35) | (1'b1 == ap_CS_fsm_state23) | (1'b1 == ap_CS_fsm_state27) | (1'b1 == ap_CS_fsm_state22) | (1'b1 == ap_CS_fsm_state26) | (1'b1 == ap_CS_fsm_state21) | (1'b1 == ap_CS_fsm_state25) | (1'b1 == ap_CS_fsm_state20) | (1'b1 == ap_CS_fsm_state24) | (1'b1 == ap_CS_fsm_state19) | (1'b1 == ap_CS_fsm_state18) | (1'b1 == ap_CS_fsm_state11) | (1'b1 == ap_CS_fsm_state4))) begin
        size_blk_n_AW = m_axi_size_AWREADY;
    end else begin
        size_blk_n_AW = 1'b1;
    end
end

always @ (*) begin
    if (((1'b1 == ap_CS_fsm_state41) | (1'b1 == ap_CS_fsm_state32) | (1'b1 == ap_CS_fsm_state31) | (1'b1 == ap_CS_fsm_state30) | (1'b1 == ap_CS_fsm_state29) | (1'b1 == ap_CS_fsm_state28) | (1'b1 == ap_CS_fsm_state27) | (1'b1 == ap_CS_fsm_state26) | (1'b1 == ap_CS_fsm_state25) | (1'b1 == ap_CS_fsm_state24) | ((icmp_ln167_reg_1919 == 1'd1) & (icmp_ln37_reg_1796 == 1'd1) & (icmp_ln36_reg_1787 == 1'd1) & (1'b1 == ap_CS_fsm_state115)) | ((icmp_ln145_reg_1899 == 1'd1) & (1'b1 == ap_CS_fsm_state104)) | ((icmp_ln115_reg_1877 == 1'd1) & (1'b1 == ap_CS_fsm_state92)) | ((icmp_ln83_reg_1855 == 1'd1) & (1'b1 == ap_CS_fsm_state78)) | ((icmp_ln59_reg_1835 == 1'd1) & (1'b1 == ap_CS_fsm_state64)) | ((icmp_ln39_reg_1816 == 1'd1) & (1'b1 == ap_CS_fsm_state52)) | ((icmp_ln11_reg_1568 == 1'd1) & (1'b1 == ap_CS_fsm_state33)) | ((icmp_ln15_reg_1592 == 1'd1) & (1'b1 == ap_CS_fsm_state17)) | ((icmp_ln12_reg_1577 == 1'd1) & (1'b1 == ap_CS_fsm_state10)))) begin
        size_blk_n_B = m_axi_size_BVALID;
    end else begin
        size_blk_n_B = 1'b1;
    end
end

always @ (*) begin
    if (((1'b1 == ap_CS_fsm_state110) | (1'b1 == ap_CS_fsm_state109) | (1'b1 == ap_CS_fsm_state108) | (1'b1 == ap_CS_fsm_state107) | (1'b1 == ap_CS_fsm_state106) | (1'b1 == ap_CS_fsm_state99) | (1'b1 == ap_CS_fsm_state98) | (1'b1 == ap_CS_fsm_state97) | (1'b1 == ap_CS_fsm_state96) | (1'b1 == ap_CS_fsm_state95) | (1'b1 == ap_CS_fsm_state94) | (1'b1 == ap_CS_fsm_state87) | (1'b1 == ap_CS_fsm_state86) | (1'b1 == ap_CS_fsm_state85) | (1'b1 == ap_CS_fsm_state84) | (1'b1 == ap_CS_fsm_state83) | (1'b1 == ap_CS_fsm_state82) | (1'b1 == ap_CS_fsm_state81) | (1'b1 == ap_CS_fsm_state80) | (1'b1 == ap_CS_fsm_state73) | (1'b1 == ap_CS_fsm_state72) | (1'b1 == ap_CS_fsm_state71) | (1'b1 == ap_CS_fsm_state70) | (1'b1 == ap_CS_fsm_state69) | (1'b1 == ap_CS_fsm_state68) | (1'b1 == ap_CS_fsm_state67) | (1'b1 == ap_CS_fsm_state66) | (1'b1 == ap_CS_fsm_state59) | (1'b1 == ap_CS_fsm_state58) | (1'b1 == ap_CS_fsm_state57) | (1'b1 == ap_CS_fsm_state56) | (1'b1 == ap_CS_fsm_state55) | (1'b1 == ap_CS_fsm_state54) | (1'b1 == ap_CS_fsm_state47) | (1'b1 == ap_CS_fsm_state46) | (1'b1 == ap_CS_fsm_state45) | (1'b1 == ap_CS_fsm_state44) | (1'b1 == ap_CS_fsm_state43) | (1'b1 == ap_CS_fsm_state36) | (1'b1 == ap_CS_fsm_state28) | (1'b1 == ap_CS_fsm_state23) | (1'b1 == ap_CS_fsm_state27) | (1'b1 == ap_CS_fsm_state22) | (1'b1 == ap_CS_fsm_state26) | (1'b1 == ap_CS_fsm_state21) | (1'b1 == ap_CS_fsm_state25) | (1'b1 == ap_CS_fsm_state20) | (1'b1 == ap_CS_fsm_state24) | (1'b1 == ap_CS_fsm_state19) | (1'b1 == ap_CS_fsm_state12) | (1'b1 == ap_CS_fsm_state5))) begin
        size_blk_n_W = m_axi_size_WREADY;
    end else begin
        size_blk_n_W = 1'b1;
    end
end

always @ (*) begin
    case (ap_CS_fsm)
        ap_ST_fsm_state1 : begin
            if (((1'b1 == ap_CS_fsm_state1) & (ap_start == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state2;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state1;
            end
        end
        ap_ST_fsm_state2 : begin
            if (((1'b1 == ap_CS_fsm_state2) & (icmp_ln11_fu_1012_p2 == 1'd0))) begin
                ap_NS_fsm = ap_ST_fsm_state33;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state3;
            end
        end
        ap_ST_fsm_state3 : begin
            if (((1'b1 == ap_CS_fsm_state3) & (icmp_ln12_fu_1018_p2 == 1'd0))) begin
                ap_NS_fsm = ap_ST_fsm_state10;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state4;
            end
        end
        ap_ST_fsm_state4 : begin
            if (((1'b1 == ap_CS_fsm_state4) & (m_axi_size_AWREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state5;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state4;
            end
        end
        ap_ST_fsm_state5 : begin
            if (((1'b1 == ap_CS_fsm_state5) & (m_axi_size_WREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state6;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state5;
            end
        end
        ap_ST_fsm_state6 : begin
            ap_NS_fsm = ap_ST_fsm_state7;
        end
        ap_ST_fsm_state7 : begin
            ap_NS_fsm = ap_ST_fsm_state8;
        end
        ap_ST_fsm_state8 : begin
            ap_NS_fsm = ap_ST_fsm_state9;
        end
        ap_ST_fsm_state9 : begin
            ap_NS_fsm = ap_ST_fsm_state10;
        end
        ap_ST_fsm_state10 : begin
            if ((~((m_axi_size_BVALID == 1'b0) & (icmp_ln12_reg_1577 == 1'd1)) & (1'b1 == ap_CS_fsm_state10) & (icmp_ln15_fu_1043_p2 == 1'd0))) begin
                ap_NS_fsm = ap_ST_fsm_state17;
            end else if ((~((m_axi_size_BVALID == 1'b0) & (icmp_ln12_reg_1577 == 1'd1)) & (icmp_ln15_fu_1043_p2 == 1'd1) & (1'b1 == ap_CS_fsm_state10))) begin
                ap_NS_fsm = ap_ST_fsm_state11;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state10;
            end
        end
        ap_ST_fsm_state11 : begin
            if (((1'b1 == ap_CS_fsm_state11) & (m_axi_size_AWREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state12;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state11;
            end
        end
        ap_ST_fsm_state12 : begin
            if (((1'b1 == ap_CS_fsm_state12) & (m_axi_size_WREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state13;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state12;
            end
        end
        ap_ST_fsm_state13 : begin
            ap_NS_fsm = ap_ST_fsm_state14;
        end
        ap_ST_fsm_state14 : begin
            ap_NS_fsm = ap_ST_fsm_state15;
        end
        ap_ST_fsm_state15 : begin
            ap_NS_fsm = ap_ST_fsm_state16;
        end
        ap_ST_fsm_state16 : begin
            ap_NS_fsm = ap_ST_fsm_state17;
        end
        ap_ST_fsm_state17 : begin
            if ((~((m_axi_size_BVALID == 1'b0) & (icmp_ln15_reg_1592 == 1'd1)) & (1'b1 == ap_CS_fsm_state17))) begin
                ap_NS_fsm = ap_ST_fsm_state18;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state17;
            end
        end
        ap_ST_fsm_state18 : begin
            if (((1'b1 == ap_CS_fsm_state18) & (m_axi_size_AWREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state19;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state18;
            end
        end
        ap_ST_fsm_state19 : begin
            if (((1'b0 == ap_block_state19_io) & (1'b1 == ap_CS_fsm_state19))) begin
                ap_NS_fsm = ap_ST_fsm_state20;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state19;
            end
        end
        ap_ST_fsm_state20 : begin
            if (((1'b0 == ap_block_state20_io) & (1'b1 == ap_CS_fsm_state20))) begin
                ap_NS_fsm = ap_ST_fsm_state21;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state20;
            end
        end
        ap_ST_fsm_state21 : begin
            if (((1'b0 == ap_block_state21_io) & (1'b1 == ap_CS_fsm_state21))) begin
                ap_NS_fsm = ap_ST_fsm_state22;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state21;
            end
        end
        ap_ST_fsm_state22 : begin
            if (((1'b0 == ap_block_state22_io) & (1'b1 == ap_CS_fsm_state22))) begin
                ap_NS_fsm = ap_ST_fsm_state23;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state22;
            end
        end
        ap_ST_fsm_state23 : begin
            if (((1'b0 == ap_block_state23_io) & (1'b1 == ap_CS_fsm_state23))) begin
                ap_NS_fsm = ap_ST_fsm_state24;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state23;
            end
        end
        ap_ST_fsm_state24 : begin
            if ((~((m_axi_size_BVALID == 1'b0) | (1'b1 == ap_block_state24_io)) & (1'b1 == ap_CS_fsm_state24))) begin
                ap_NS_fsm = ap_ST_fsm_state25;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state24;
            end
        end
        ap_ST_fsm_state25 : begin
            if ((~((m_axi_size_BVALID == 1'b0) | (1'b1 == ap_block_state25_io)) & (1'b1 == ap_CS_fsm_state25))) begin
                ap_NS_fsm = ap_ST_fsm_state26;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state25;
            end
        end
        ap_ST_fsm_state26 : begin
            if ((~((m_axi_size_BVALID == 1'b0) | (1'b1 == ap_block_state26_io)) & (1'b1 == ap_CS_fsm_state26))) begin
                ap_NS_fsm = ap_ST_fsm_state27;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state26;
            end
        end
        ap_ST_fsm_state27 : begin
            if ((~((m_axi_size_BVALID == 1'b0) | (1'b1 == ap_block_state27_io)) & (1'b1 == ap_CS_fsm_state27))) begin
                ap_NS_fsm = ap_ST_fsm_state28;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state27;
            end
        end
        ap_ST_fsm_state28 : begin
            if ((~((m_axi_size_BVALID == 1'b0) | (m_axi_size_WREADY == 1'b0)) & (1'b1 == ap_CS_fsm_state28))) begin
                ap_NS_fsm = ap_ST_fsm_state29;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state28;
            end
        end
        ap_ST_fsm_state29 : begin
            if (((1'b1 == ap_CS_fsm_state29) & (m_axi_size_BVALID == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state30;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state29;
            end
        end
        ap_ST_fsm_state30 : begin
            if (((1'b1 == ap_CS_fsm_state30) & (m_axi_size_BVALID == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state31;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state30;
            end
        end
        ap_ST_fsm_state31 : begin
            if (((1'b1 == ap_CS_fsm_state31) & (m_axi_size_BVALID == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state32;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state31;
            end
        end
        ap_ST_fsm_state32 : begin
            if (((1'b1 == ap_CS_fsm_state32) & (m_axi_size_BVALID == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state33;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state32;
            end
        end
        ap_ST_fsm_state33 : begin
            if ((~((m_axi_size_BVALID == 1'b0) & (icmp_ln11_reg_1568 == 1'd1)) & (1'b1 == ap_CS_fsm_state33) & (icmp_ln36_fu_1337_p2 == 1'd0))) begin
                ap_NS_fsm = ap_ST_fsm_state115;
            end else if ((~((m_axi_size_BVALID == 1'b0) & (icmp_ln11_reg_1568 == 1'd1)) & (icmp_ln36_fu_1337_p2 == 1'd1) & (1'b1 == ap_CS_fsm_state33))) begin
                ap_NS_fsm = ap_ST_fsm_state34;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state33;
            end
        end
        ap_ST_fsm_state34 : begin
            if (((1'b1 == ap_CS_fsm_state34) & (icmp_ln37_fu_1342_p2 == 1'd0))) begin
                ap_NS_fsm = ap_ST_fsm_state115;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state35;
            end
        end
        ap_ST_fsm_state35 : begin
            if (((1'b1 == ap_CS_fsm_state35) & (m_axi_size_AWREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state36;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state35;
            end
        end
        ap_ST_fsm_state36 : begin
            if (((1'b1 == ap_CS_fsm_state36) & (m_axi_size_WREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state37;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state36;
            end
        end
        ap_ST_fsm_state37 : begin
            ap_NS_fsm = ap_ST_fsm_state38;
        end
        ap_ST_fsm_state38 : begin
            ap_NS_fsm = ap_ST_fsm_state39;
        end
        ap_ST_fsm_state39 : begin
            ap_NS_fsm = ap_ST_fsm_state40;
        end
        ap_ST_fsm_state40 : begin
            ap_NS_fsm = ap_ST_fsm_state41;
        end
        ap_ST_fsm_state41 : begin
            if (((1'b1 == ap_CS_fsm_state41) & (icmp_ln39_fu_1367_p2 == 1'd0) & (m_axi_size_BVALID == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state52;
            end else if (((icmp_ln39_fu_1367_p2 == 1'd1) & (1'b1 == ap_CS_fsm_state41) & (m_axi_size_BVALID == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state42;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state41;
            end
        end
        ap_ST_fsm_state42 : begin
            if (((1'b1 == ap_CS_fsm_state42) & (m_axi_size_AWREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state43;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state42;
            end
        end
        ap_ST_fsm_state43 : begin
            if (((1'b1 == ap_CS_fsm_state43) & (m_axi_size_WREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state44;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state43;
            end
        end
        ap_ST_fsm_state44 : begin
            if (((1'b1 == ap_CS_fsm_state44) & (m_axi_size_WREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state45;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state44;
            end
        end
        ap_ST_fsm_state45 : begin
            if (((1'b1 == ap_CS_fsm_state45) & (m_axi_size_WREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state46;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state45;
            end
        end
        ap_ST_fsm_state46 : begin
            if (((1'b1 == ap_CS_fsm_state46) & (m_axi_size_WREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state47;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state46;
            end
        end
        ap_ST_fsm_state47 : begin
            if (((1'b1 == ap_CS_fsm_state47) & (m_axi_size_WREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state48;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state47;
            end
        end
        ap_ST_fsm_state48 : begin
            ap_NS_fsm = ap_ST_fsm_state49;
        end
        ap_ST_fsm_state49 : begin
            ap_NS_fsm = ap_ST_fsm_state50;
        end
        ap_ST_fsm_state50 : begin
            ap_NS_fsm = ap_ST_fsm_state51;
        end
        ap_ST_fsm_state51 : begin
            ap_NS_fsm = ap_ST_fsm_state52;
        end
        ap_ST_fsm_state52 : begin
            if ((~((m_axi_size_BVALID == 1'b0) & (icmp_ln39_reg_1816 == 1'd1)) & (1'b1 == ap_CS_fsm_state52) & (icmp_ln59_fu_1392_p2 == 1'd0))) begin
                ap_NS_fsm = ap_ST_fsm_state64;
            end else if ((~((m_axi_size_BVALID == 1'b0) & (icmp_ln39_reg_1816 == 1'd1)) & (icmp_ln59_fu_1392_p2 == 1'd1) & (1'b1 == ap_CS_fsm_state52))) begin
                ap_NS_fsm = ap_ST_fsm_state53;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state52;
            end
        end
        ap_ST_fsm_state53 : begin
            if (((1'b1 == ap_CS_fsm_state53) & (m_axi_size_AWREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state54;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state53;
            end
        end
        ap_ST_fsm_state54 : begin
            if (((1'b1 == ap_CS_fsm_state54) & (m_axi_size_WREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state55;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state54;
            end
        end
        ap_ST_fsm_state55 : begin
            if (((1'b1 == ap_CS_fsm_state55) & (m_axi_size_WREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state56;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state55;
            end
        end
        ap_ST_fsm_state56 : begin
            if (((1'b1 == ap_CS_fsm_state56) & (m_axi_size_WREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state57;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state56;
            end
        end
        ap_ST_fsm_state57 : begin
            if (((1'b1 == ap_CS_fsm_state57) & (m_axi_size_WREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state58;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state57;
            end
        end
        ap_ST_fsm_state58 : begin
            if (((1'b1 == ap_CS_fsm_state58) & (m_axi_size_WREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state59;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state58;
            end
        end
        ap_ST_fsm_state59 : begin
            if (((1'b1 == ap_CS_fsm_state59) & (m_axi_size_WREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state60;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state59;
            end
        end
        ap_ST_fsm_state60 : begin
            ap_NS_fsm = ap_ST_fsm_state61;
        end
        ap_ST_fsm_state61 : begin
            ap_NS_fsm = ap_ST_fsm_state62;
        end
        ap_ST_fsm_state62 : begin
            ap_NS_fsm = ap_ST_fsm_state63;
        end
        ap_ST_fsm_state63 : begin
            ap_NS_fsm = ap_ST_fsm_state64;
        end
        ap_ST_fsm_state64 : begin
            if ((~((m_axi_size_BVALID == 1'b0) & (icmp_ln59_reg_1835 == 1'd1)) & (1'b1 == ap_CS_fsm_state64) & (icmp_ln83_fu_1417_p2 == 1'd0))) begin
                ap_NS_fsm = ap_ST_fsm_state78;
            end else if ((~((m_axi_size_BVALID == 1'b0) & (icmp_ln59_reg_1835 == 1'd1)) & (icmp_ln83_fu_1417_p2 == 1'd1) & (1'b1 == ap_CS_fsm_state64))) begin
                ap_NS_fsm = ap_ST_fsm_state65;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state64;
            end
        end
        ap_ST_fsm_state65 : begin
            if (((1'b1 == ap_CS_fsm_state65) & (m_axi_size_AWREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state66;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state65;
            end
        end
        ap_ST_fsm_state66 : begin
            if (((1'b1 == ap_CS_fsm_state66) & (m_axi_size_WREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state67;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state66;
            end
        end
        ap_ST_fsm_state67 : begin
            if (((1'b1 == ap_CS_fsm_state67) & (m_axi_size_WREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state68;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state67;
            end
        end
        ap_ST_fsm_state68 : begin
            if (((1'b1 == ap_CS_fsm_state68) & (m_axi_size_WREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state69;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state68;
            end
        end
        ap_ST_fsm_state69 : begin
            if (((1'b1 == ap_CS_fsm_state69) & (m_axi_size_WREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state70;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state69;
            end
        end
        ap_ST_fsm_state70 : begin
            if (((1'b1 == ap_CS_fsm_state70) & (m_axi_size_WREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state71;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state70;
            end
        end
        ap_ST_fsm_state71 : begin
            if (((1'b1 == ap_CS_fsm_state71) & (m_axi_size_WREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state72;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state71;
            end
        end
        ap_ST_fsm_state72 : begin
            if (((1'b1 == ap_CS_fsm_state72) & (m_axi_size_WREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state73;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state72;
            end
        end
        ap_ST_fsm_state73 : begin
            if (((1'b1 == ap_CS_fsm_state73) & (m_axi_size_WREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state74;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state73;
            end
        end
        ap_ST_fsm_state74 : begin
            ap_NS_fsm = ap_ST_fsm_state75;
        end
        ap_ST_fsm_state75 : begin
            ap_NS_fsm = ap_ST_fsm_state76;
        end
        ap_ST_fsm_state76 : begin
            ap_NS_fsm = ap_ST_fsm_state77;
        end
        ap_ST_fsm_state77 : begin
            ap_NS_fsm = ap_ST_fsm_state78;
        end
        ap_ST_fsm_state78 : begin
            if ((~((m_axi_size_BVALID == 1'b0) & (icmp_ln83_reg_1855 == 1'd1)) & (1'b1 == ap_CS_fsm_state78) & (icmp_ln115_fu_1442_p2 == 1'd0))) begin
                ap_NS_fsm = ap_ST_fsm_state92;
            end else if ((~((m_axi_size_BVALID == 1'b0) & (icmp_ln83_reg_1855 == 1'd1)) & (icmp_ln115_fu_1442_p2 == 1'd1) & (1'b1 == ap_CS_fsm_state78))) begin
                ap_NS_fsm = ap_ST_fsm_state79;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state78;
            end
        end
        ap_ST_fsm_state79 : begin
            if (((1'b1 == ap_CS_fsm_state79) & (m_axi_size_AWREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state80;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state79;
            end
        end
        ap_ST_fsm_state80 : begin
            if (((1'b1 == ap_CS_fsm_state80) & (m_axi_size_WREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state81;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state80;
            end
        end
        ap_ST_fsm_state81 : begin
            if (((1'b1 == ap_CS_fsm_state81) & (m_axi_size_WREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state82;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state81;
            end
        end
        ap_ST_fsm_state82 : begin
            if (((1'b1 == ap_CS_fsm_state82) & (m_axi_size_WREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state83;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state82;
            end
        end
        ap_ST_fsm_state83 : begin
            if (((1'b1 == ap_CS_fsm_state83) & (m_axi_size_WREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state84;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state83;
            end
        end
        ap_ST_fsm_state84 : begin
            if (((1'b1 == ap_CS_fsm_state84) & (m_axi_size_WREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state85;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state84;
            end
        end
        ap_ST_fsm_state85 : begin
            if (((1'b1 == ap_CS_fsm_state85) & (m_axi_size_WREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state86;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state85;
            end
        end
        ap_ST_fsm_state86 : begin
            if (((1'b1 == ap_CS_fsm_state86) & (m_axi_size_WREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state87;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state86;
            end
        end
        ap_ST_fsm_state87 : begin
            if (((1'b1 == ap_CS_fsm_state87) & (m_axi_size_WREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state88;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state87;
            end
        end
        ap_ST_fsm_state88 : begin
            ap_NS_fsm = ap_ST_fsm_state89;
        end
        ap_ST_fsm_state89 : begin
            ap_NS_fsm = ap_ST_fsm_state90;
        end
        ap_ST_fsm_state90 : begin
            ap_NS_fsm = ap_ST_fsm_state91;
        end
        ap_ST_fsm_state91 : begin
            ap_NS_fsm = ap_ST_fsm_state92;
        end
        ap_ST_fsm_state92 : begin
            if ((~((m_axi_size_BVALID == 1'b0) & (icmp_ln115_reg_1877 == 1'd1)) & (1'b1 == ap_CS_fsm_state92) & (icmp_ln145_fu_1467_p2 == 1'd0))) begin
                ap_NS_fsm = ap_ST_fsm_state104;
            end else if ((~((m_axi_size_BVALID == 1'b0) & (icmp_ln115_reg_1877 == 1'd1)) & (icmp_ln145_fu_1467_p2 == 1'd1) & (1'b1 == ap_CS_fsm_state92))) begin
                ap_NS_fsm = ap_ST_fsm_state93;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state92;
            end
        end
        ap_ST_fsm_state93 : begin
            if (((1'b1 == ap_CS_fsm_state93) & (m_axi_size_AWREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state94;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state93;
            end
        end
        ap_ST_fsm_state94 : begin
            if (((1'b1 == ap_CS_fsm_state94) & (m_axi_size_WREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state95;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state94;
            end
        end
        ap_ST_fsm_state95 : begin
            if (((1'b1 == ap_CS_fsm_state95) & (m_axi_size_WREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state96;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state95;
            end
        end
        ap_ST_fsm_state96 : begin
            if (((1'b1 == ap_CS_fsm_state96) & (m_axi_size_WREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state97;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state96;
            end
        end
        ap_ST_fsm_state97 : begin
            if (((1'b1 == ap_CS_fsm_state97) & (m_axi_size_WREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state98;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state97;
            end
        end
        ap_ST_fsm_state98 : begin
            if (((1'b1 == ap_CS_fsm_state98) & (m_axi_size_WREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state99;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state98;
            end
        end
        ap_ST_fsm_state99 : begin
            if (((1'b1 == ap_CS_fsm_state99) & (m_axi_size_WREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state100;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state99;
            end
        end
        ap_ST_fsm_state100 : begin
            ap_NS_fsm = ap_ST_fsm_state101;
        end
        ap_ST_fsm_state101 : begin
            ap_NS_fsm = ap_ST_fsm_state102;
        end
        ap_ST_fsm_state102 : begin
            ap_NS_fsm = ap_ST_fsm_state103;
        end
        ap_ST_fsm_state103 : begin
            ap_NS_fsm = ap_ST_fsm_state104;
        end
        ap_ST_fsm_state104 : begin
            if ((~((m_axi_size_BVALID == 1'b0) & (icmp_ln145_reg_1899 == 1'd1)) & (1'b1 == ap_CS_fsm_state104) & (icmp_ln167_fu_1492_p2 == 1'd0))) begin
                ap_NS_fsm = ap_ST_fsm_state115;
            end else if ((~((m_axi_size_BVALID == 1'b0) & (icmp_ln145_reg_1899 == 1'd1)) & (icmp_ln167_fu_1492_p2 == 1'd1) & (1'b1 == ap_CS_fsm_state104))) begin
                ap_NS_fsm = ap_ST_fsm_state105;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state104;
            end
        end
        ap_ST_fsm_state105 : begin
            if (((1'b1 == ap_CS_fsm_state105) & (m_axi_size_AWREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state106;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state105;
            end
        end
        ap_ST_fsm_state106 : begin
            if (((1'b1 == ap_CS_fsm_state106) & (m_axi_size_WREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state107;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state106;
            end
        end
        ap_ST_fsm_state107 : begin
            if (((1'b1 == ap_CS_fsm_state107) & (m_axi_size_WREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state108;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state107;
            end
        end
        ap_ST_fsm_state108 : begin
            if (((1'b1 == ap_CS_fsm_state108) & (m_axi_size_WREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state109;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state108;
            end
        end
        ap_ST_fsm_state109 : begin
            if (((1'b1 == ap_CS_fsm_state109) & (m_axi_size_WREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state110;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state109;
            end
        end
        ap_ST_fsm_state110 : begin
            if (((1'b1 == ap_CS_fsm_state110) & (m_axi_size_WREADY == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state111;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state110;
            end
        end
        ap_ST_fsm_state111 : begin
            ap_NS_fsm = ap_ST_fsm_state112;
        end
        ap_ST_fsm_state112 : begin
            ap_NS_fsm = ap_ST_fsm_state113;
        end
        ap_ST_fsm_state113 : begin
            ap_NS_fsm = ap_ST_fsm_state114;
        end
        ap_ST_fsm_state114 : begin
            ap_NS_fsm = ap_ST_fsm_state115;
        end
        ap_ST_fsm_state115 : begin
            if ((~((m_axi_size_BVALID == 1'b0) & (ap_predicate_op469_writeresp_state115 == 1'b1)) & (1'b1 == ap_CS_fsm_state115))) begin
                ap_NS_fsm = ap_ST_fsm_state1;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state115;
            end
        end
        default : begin
            ap_NS_fsm = 'bx;
        end
    endcase
end

assign add_ln116_fu_1451_p2 = (zext_ln116_fu_1448_p1 + 31'd7);

assign add_ln13_fu_1027_p2 = (zext_ln13_fu_1024_p1 + 31'd1);

assign add_ln146_fu_1476_p2 = (zext_ln146_fu_1473_p1 + 31'd7);

assign add_ln168_fu_1501_p2 = (zext_ln168_fu_1498_p1 + 31'd7);

assign add_ln16_fu_1052_p2 = (zext_ln16_fu_1049_p1 + 31'd1);

assign add_ln21_3_fu_1120_p2 = (zext_ln21_reg_1612 + 31'd3);

assign add_ln21_fu_1071_p2 = (zext_ln21_fu_1068_p1 + 31'd2);

assign add_ln24_1_fu_1236_p2 = ($signed(sext_ln24_1_fu_1223_p1) + $signed(sext_ln24_2_fu_1227_p1));

assign add_ln24_2_fu_1246_p2 = ($signed(sext_ln24_4_fu_1242_p1) + $signed(add_ln24_fu_1230_p2));

assign add_ln24_5_fu_1179_p2 = (zext_ln24_fu_1176_p1 + 31'd1);

assign add_ln24_fu_1230_p2 = ($signed(shl_ln_fu_1196_p3) + $signed(sext_ln24_fu_1212_p1));

assign add_ln27_1_fu_1311_p2 = ($signed(sext_ln27_1_fu_1297_p1) + $signed(sext_ln27_2_fu_1301_p1));

assign add_ln27_2_fu_1321_p2 = ($signed(sext_ln27_3_fu_1317_p1) + $signed(add_ln27_fu_1305_p2));

assign add_ln27_5_fu_1265_p2 = (zext_ln27_fu_1262_p1 + 31'd1);

assign add_ln27_fu_1305_p2 = ($signed(shl_ln3_fu_1271_p3) + $signed(sext_ln27_fu_1285_p1));

assign add_ln38_fu_1351_p2 = (zext_ln38_fu_1348_p1 + 31'd1);

assign add_ln40_fu_1376_p2 = (zext_ln40_fu_1373_p1 + 31'd7);

assign add_ln60_fu_1401_p2 = (zext_ln60_fu_1398_p1 + 31'd7);

assign add_ln84_fu_1426_p2 = (zext_ln84_fu_1423_p1 + 31'd7);

assign ap_CS_fsm_state1 = ap_CS_fsm[32'd0];

assign ap_CS_fsm_state10 = ap_CS_fsm[32'd9];

assign ap_CS_fsm_state104 = ap_CS_fsm[32'd103];

assign ap_CS_fsm_state105 = ap_CS_fsm[32'd104];

assign ap_CS_fsm_state106 = ap_CS_fsm[32'd105];

assign ap_CS_fsm_state107 = ap_CS_fsm[32'd106];

assign ap_CS_fsm_state108 = ap_CS_fsm[32'd107];

assign ap_CS_fsm_state109 = ap_CS_fsm[32'd108];

assign ap_CS_fsm_state11 = ap_CS_fsm[32'd10];

assign ap_CS_fsm_state110 = ap_CS_fsm[32'd109];

assign ap_CS_fsm_state115 = ap_CS_fsm[32'd114];

assign ap_CS_fsm_state12 = ap_CS_fsm[32'd11];

assign ap_CS_fsm_state17 = ap_CS_fsm[32'd16];

assign ap_CS_fsm_state18 = ap_CS_fsm[32'd17];

assign ap_CS_fsm_state19 = ap_CS_fsm[32'd18];

assign ap_CS_fsm_state2 = ap_CS_fsm[32'd1];

assign ap_CS_fsm_state20 = ap_CS_fsm[32'd19];

assign ap_CS_fsm_state21 = ap_CS_fsm[32'd20];

assign ap_CS_fsm_state22 = ap_CS_fsm[32'd21];

assign ap_CS_fsm_state23 = ap_CS_fsm[32'd22];

assign ap_CS_fsm_state24 = ap_CS_fsm[32'd23];

assign ap_CS_fsm_state25 = ap_CS_fsm[32'd24];

assign ap_CS_fsm_state26 = ap_CS_fsm[32'd25];

assign ap_CS_fsm_state27 = ap_CS_fsm[32'd26];

assign ap_CS_fsm_state28 = ap_CS_fsm[32'd27];

assign ap_CS_fsm_state29 = ap_CS_fsm[32'd28];

assign ap_CS_fsm_state3 = ap_CS_fsm[32'd2];

assign ap_CS_fsm_state30 = ap_CS_fsm[32'd29];

assign ap_CS_fsm_state31 = ap_CS_fsm[32'd30];

assign ap_CS_fsm_state32 = ap_CS_fsm[32'd31];

assign ap_CS_fsm_state33 = ap_CS_fsm[32'd32];

assign ap_CS_fsm_state34 = ap_CS_fsm[32'd33];

assign ap_CS_fsm_state35 = ap_CS_fsm[32'd34];

assign ap_CS_fsm_state36 = ap_CS_fsm[32'd35];

assign ap_CS_fsm_state4 = ap_CS_fsm[32'd3];

assign ap_CS_fsm_state40 = ap_CS_fsm[32'd39];

assign ap_CS_fsm_state41 = ap_CS_fsm[32'd40];

assign ap_CS_fsm_state42 = ap_CS_fsm[32'd41];

assign ap_CS_fsm_state43 = ap_CS_fsm[32'd42];

assign ap_CS_fsm_state44 = ap_CS_fsm[32'd43];

assign ap_CS_fsm_state45 = ap_CS_fsm[32'd44];

assign ap_CS_fsm_state46 = ap_CS_fsm[32'd45];

assign ap_CS_fsm_state47 = ap_CS_fsm[32'd46];

assign ap_CS_fsm_state5 = ap_CS_fsm[32'd4];

assign ap_CS_fsm_state52 = ap_CS_fsm[32'd51];

assign ap_CS_fsm_state53 = ap_CS_fsm[32'd52];

assign ap_CS_fsm_state54 = ap_CS_fsm[32'd53];

assign ap_CS_fsm_state55 = ap_CS_fsm[32'd54];

assign ap_CS_fsm_state56 = ap_CS_fsm[32'd55];

assign ap_CS_fsm_state57 = ap_CS_fsm[32'd56];

assign ap_CS_fsm_state58 = ap_CS_fsm[32'd57];

assign ap_CS_fsm_state59 = ap_CS_fsm[32'd58];

assign ap_CS_fsm_state64 = ap_CS_fsm[32'd63];

assign ap_CS_fsm_state65 = ap_CS_fsm[32'd64];

assign ap_CS_fsm_state66 = ap_CS_fsm[32'd65];

assign ap_CS_fsm_state67 = ap_CS_fsm[32'd66];

assign ap_CS_fsm_state68 = ap_CS_fsm[32'd67];

assign ap_CS_fsm_state69 = ap_CS_fsm[32'd68];

assign ap_CS_fsm_state70 = ap_CS_fsm[32'd69];

assign ap_CS_fsm_state71 = ap_CS_fsm[32'd70];

assign ap_CS_fsm_state72 = ap_CS_fsm[32'd71];

assign ap_CS_fsm_state73 = ap_CS_fsm[32'd72];

assign ap_CS_fsm_state78 = ap_CS_fsm[32'd77];

assign ap_CS_fsm_state79 = ap_CS_fsm[32'd78];

assign ap_CS_fsm_state80 = ap_CS_fsm[32'd79];

assign ap_CS_fsm_state81 = ap_CS_fsm[32'd80];

assign ap_CS_fsm_state82 = ap_CS_fsm[32'd81];

assign ap_CS_fsm_state83 = ap_CS_fsm[32'd82];

assign ap_CS_fsm_state84 = ap_CS_fsm[32'd83];

assign ap_CS_fsm_state85 = ap_CS_fsm[32'd84];

assign ap_CS_fsm_state86 = ap_CS_fsm[32'd85];

assign ap_CS_fsm_state87 = ap_CS_fsm[32'd86];

assign ap_CS_fsm_state92 = ap_CS_fsm[32'd91];

assign ap_CS_fsm_state93 = ap_CS_fsm[32'd92];

assign ap_CS_fsm_state94 = ap_CS_fsm[32'd93];

assign ap_CS_fsm_state95 = ap_CS_fsm[32'd94];

assign ap_CS_fsm_state96 = ap_CS_fsm[32'd95];

assign ap_CS_fsm_state97 = ap_CS_fsm[32'd96];

assign ap_CS_fsm_state98 = ap_CS_fsm[32'd97];

assign ap_CS_fsm_state99 = ap_CS_fsm[32'd98];

always @ (*) begin
    ap_block_state10 = ((m_axi_size_BVALID == 1'b0) & (icmp_ln12_reg_1577 == 1'd1));
end

always @ (*) begin
    ap_block_state104 = ((m_axi_size_BVALID == 1'b0) & (icmp_ln145_reg_1899 == 1'd1));
end

always @ (*) begin
    ap_block_state115 = ((m_axi_size_BVALID == 1'b0) & (ap_predicate_op469_writeresp_state115 == 1'b1));
end

always @ (*) begin
    ap_block_state17 = ((m_axi_size_BVALID == 1'b0) & (icmp_ln15_reg_1592 == 1'd1));
end

always @ (*) begin
    ap_block_state19_io = ((m_axi_size_WREADY == 1'b0) | (m_axi_size_AWREADY == 1'b0));
end

always @ (*) begin
    ap_block_state20_io = ((m_axi_size_WREADY == 1'b0) | (m_axi_size_AWREADY == 1'b0));
end

always @ (*) begin
    ap_block_state21_io = ((m_axi_size_WREADY == 1'b0) | (m_axi_size_AWREADY == 1'b0));
end

always @ (*) begin
    ap_block_state22_io = ((m_axi_size_WREADY == 1'b0) | (m_axi_size_AWREADY == 1'b0));
end

always @ (*) begin
    ap_block_state23_io = ((m_axi_size_WREADY == 1'b0) | (m_axi_size_AWREADY == 1'b0));
end

always @ (*) begin
    ap_block_state24_io = ((m_axi_size_WREADY == 1'b0) | (m_axi_size_AWREADY == 1'b0));
end

always @ (*) begin
    ap_block_state25_io = ((m_axi_size_WREADY == 1'b0) | (m_axi_size_AWREADY == 1'b0));
end

always @ (*) begin
    ap_block_state26_io = ((m_axi_size_WREADY == 1'b0) | (m_axi_size_AWREADY == 1'b0));
end

always @ (*) begin
    ap_block_state27_io = ((m_axi_size_WREADY == 1'b0) | (m_axi_size_AWREADY == 1'b0));
end

always @ (*) begin
    ap_block_state33 = ((m_axi_size_BVALID == 1'b0) & (icmp_ln11_reg_1568 == 1'd1));
end

always @ (*) begin
    ap_block_state52 = ((m_axi_size_BVALID == 1'b0) & (icmp_ln39_reg_1816 == 1'd1));
end

always @ (*) begin
    ap_block_state64 = ((m_axi_size_BVALID == 1'b0) & (icmp_ln59_reg_1835 == 1'd1));
end

always @ (*) begin
    ap_block_state78 = ((m_axi_size_BVALID == 1'b0) & (icmp_ln83_reg_1855 == 1'd1));
end

always @ (*) begin
    ap_block_state92 = ((m_axi_size_BVALID == 1'b0) & (icmp_ln115_reg_1877 == 1'd1));
end

always @ (*) begin
    ap_predicate_op469_writeresp_state115 = ((icmp_ln167_reg_1919 == 1'd1) & (icmp_ln37_reg_1796 == 1'd1) & (icmp_ln36_reg_1787 == 1'd1));
end

assign icmp_ln115_fu_1442_p2 = ((reg_987 == 8'd77) ? 1'b1 : 1'b0);

assign icmp_ln11_fu_1012_p2 = ((tmp_fu_1004_p3 == 16'd80) ? 1'b1 : 1'b0);

assign icmp_ln12_fu_1018_p2 = ((dest_array_q0 == 8'd53) ? 1'b1 : 1'b0);

assign icmp_ln145_fu_1467_p2 = ((reg_987 == 8'd69) ? 1'b1 : 1'b0);

assign icmp_ln15_fu_1043_p2 = ((reg_987 == 8'd56) ? 1'b1 : 1'b0);

assign icmp_ln167_fu_1492_p2 = ((reg_987 == 8'd67) ? 1'b1 : 1'b0);

assign icmp_ln36_fu_1337_p2 = ((tmp_reg_1563 == 16'd60) ? 1'b1 : 1'b0);

assign icmp_ln37_fu_1342_p2 = ((dest_array_q1 == 8'd83) ? 1'b1 : 1'b0);

assign icmp_ln39_fu_1367_p2 = ((dest_array_q0 == 8'd79) ? 1'b1 : 1'b0);

assign icmp_ln59_fu_1392_p2 = ((reg_987 == 8'd83) ? 1'b1 : 1'b0);

assign icmp_ln83_fu_1417_p2 = ((reg_987 == 8'd82) ? 1'b1 : 1'b0);

assign m_axi_size_ARADDR = 32'd0;

assign m_axi_size_ARBURST = 2'd0;

assign m_axi_size_ARCACHE = 4'd0;

assign m_axi_size_ARID = 1'd0;

assign m_axi_size_ARLEN = 32'd0;

assign m_axi_size_ARLOCK = 2'd0;

assign m_axi_size_ARPROT = 3'd0;

assign m_axi_size_ARQOS = 4'd0;

assign m_axi_size_ARREGION = 4'd0;

assign m_axi_size_ARSIZE = 3'd0;

assign m_axi_size_ARUSER = 1'd0;

assign m_axi_size_ARVALID = 1'b0;

assign m_axi_size_AWBURST = 2'd0;

assign m_axi_size_AWCACHE = 4'd0;

assign m_axi_size_AWID = 1'd0;

assign m_axi_size_AWLOCK = 2'd0;

assign m_axi_size_AWPROT = 3'd0;

assign m_axi_size_AWQOS = 4'd0;

assign m_axi_size_AWREGION = 4'd0;

assign m_axi_size_AWSIZE = 3'd0;

assign m_axi_size_AWUSER = 1'd0;

assign m_axi_size_RREADY = 1'b0;

assign m_axi_size_WID = 1'd0;

assign m_axi_size_WLAST = 1'b0;

assign m_axi_size_WUSER = 1'd0;

assign sext_ln24_1_fu_1223_p1 = $signed(shl_ln24_2_fu_1216_p3);

assign sext_ln24_2_fu_1227_p1 = $signed(dest_array_load_7_reg_1720);

assign sext_ln24_4_fu_1242_p1 = $signed(add_ln24_1_fu_1236_p2);

assign sext_ln24_fu_1212_p1 = $signed(shl_ln24_1_fu_1204_p3);

assign sext_ln27_1_fu_1297_p1 = $signed(shl_ln27_2_fu_1289_p3);

assign sext_ln27_2_fu_1301_p1 = $signed(reg_992);

assign sext_ln27_3_fu_1317_p1 = $signed(add_ln27_1_fu_1311_p2);

assign sext_ln27_fu_1285_p1 = $signed(shl_ln27_1_fu_1278_p3);

assign shl_ln24_1_fu_1204_p3 = {{reg_1000}, {16'd0}};

assign shl_ln24_2_fu_1216_p3 = {{dest_array_load_6_reg_1715}, {8'd0}};

assign shl_ln27_1_fu_1278_p3 = {{dest_array_load_13_reg_1745}, {16'd0}};

assign shl_ln27_2_fu_1289_p3 = {{reg_987}, {8'd0}};

assign shl_ln3_fu_1271_p3 = {{dest_array_load_12_reg_1740}, {24'd0}};

assign shl_ln_fu_1196_p3 = {{reg_996}, {24'd0}};

assign tmp_10_fu_1092_p3 = {{reg_992}, {reg_987}};

assign tmp_11_fu_1105_p4 = {{{reg_996}, {reg_992}}, {reg_987}};

assign tmp_12_fu_1152_p3 = {{dest_array_load_16_reg_1669}, {dest_array_load_11_reg_1656}};

assign tmp_13_fu_1163_p4 = {{{reg_987}, {dest_array_load_16_reg_1669}}, {dest_array_load_11_reg_1656}};

assign tmp_2_fu_1185_p5 = {{{{reg_992}, {reg_987}}, {dest_array_load_16_reg_1669}}, {dest_array_load_11_reg_1656}};

assign tmp_fu_1004_p3 = {{dest_array_q0}, {dest_array_q1}};

assign tmp_s_fu_1125_p5 = {{{{reg_1000}, {reg_996}}, {reg_992}}, {reg_987}};

assign zext_ln116_3_fu_1457_p1 = add_ln116_reg_1881;

assign zext_ln116_fu_1448_p1 = system_event_message_offset;

assign zext_ln13_3_fu_1033_p1 = add_ln13_reg_1581;

assign zext_ln13_fu_1024_p1 = sell_or_buy_offset;

assign zext_ln146_3_fu_1482_p1 = add_ln146_reg_1903;

assign zext_ln146_fu_1473_p1 = system_event_message_offset;

assign zext_ln168_3_fu_1507_p1 = add_ln168_reg_1923;

assign zext_ln168_fu_1498_p1 = system_event_message_offset;

assign zext_ln16_3_fu_1058_p1 = add_ln16_reg_1596;

assign zext_ln16_fu_1049_p1 = sell_or_buy_offset;

assign zext_ln21_17_fu_1077_p1 = add_ln21_reg_1617;

assign zext_ln21_18_fu_1087_p1 = reg_987;

assign zext_ln21_19_fu_1100_p1 = tmp_10_fu_1092_p3;

assign zext_ln21_20_fu_1115_p1 = tmp_11_fu_1105_p4;

assign zext_ln21_21_fu_1138_p1 = add_ln21_3_reg_1664;

assign zext_ln21_22_fu_1148_p1 = dest_array_load_11_reg_1656;

assign zext_ln21_23_fu_1158_p1 = tmp_12_fu_1152_p3;

assign zext_ln21_24_fu_1171_p1 = tmp_13_fu_1163_p4;

assign zext_ln21_fu_1068_p1 = symbol_offset;

assign zext_ln24_3_fu_1252_p1 = add_ln24_5_reg_1735;

assign zext_ln24_fu_1176_p1 = size_offset;

assign zext_ln27_3_fu_1327_p1 = add_ln27_5_reg_1771;

assign zext_ln27_fu_1262_p1 = price_offset;

assign zext_ln38_3_fu_1357_p1 = add_ln38_reg_1800;

assign zext_ln38_fu_1348_p1 = is_system_event_offset;

assign zext_ln40_3_fu_1382_p1 = add_ln40_reg_1820;

assign zext_ln40_fu_1373_p1 = system_event_message_offset;

assign zext_ln60_3_fu_1407_p1 = add_ln60_reg_1839;

assign zext_ln60_fu_1398_p1 = system_event_message_offset;

assign zext_ln84_3_fu_1432_p1 = add_ln84_reg_1859;

assign zext_ln84_fu_1423_p1 = system_event_message_offset;

always @ (posedge ap_clk) begin
    zext_ln21_reg_1612[30] <= 1'b0;
    size_addr_26_reg_1622[31] <= 1'b0;
    size_addr_27_reg_1686[31] <= 1'b0;
end

endmodule //decode_message6
